#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//#include <windows.h>
#include <GL/gl.h>
#include <GL/glut.h>

#include <time.h>
//#include "util.h"
#include "h.h"

#define sizex 512
#define sizey 512

poly_t *tpoly;
int npoly;

double coef=0.5;
double gammaa=0.5;

long long int otime;
int r=0;
int l1=0,l2=100,l0=1,lr=0,l3=0;

float vrx=0.0,vry=0.0,vrz=0.0;
float cx=0.0,cy=0.0,cz=0.0;

int wireframe=1;
int plain=0;
int normcull=0;

/******************* OPENGL **********************/
static void
idle(void)
{
  glutPostRedisplay();
}

static void
special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    vrx+=3;
    break;
  case GLUT_KEY_DOWN:
    vrx-=3;
    break;
  case GLUT_KEY_LEFT:
    vry+=3;
    break;
  case GLUT_KEY_RIGHT:
    vry-=3;
    break;
  default:
    return;
  }
  printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  glutPostRedisplay();
}

static void
key(unsigned char k, int x, int y)
{
#define CD M_PI/180.
  if(k=='w')
    wireframe=1-wireframe;
  if(k=='p')
    plain=1-plain;
  if(k=='n')
    normcull=1-normcull;
  //if(k==' ')
  //  l0=1-l0;
  if(k=='+'|| k=='-') { 
    float v[3]={-0.05,0.,0.},v2[3];
    v2[1]=v[1];
    v2[0]=cos(vrx*CD)*v[0]-sin(vrx*CD)*v[2];
    v2[2]=sin(vrx*CD)*v[0]+cos(vrx*CD)*v[2];
    v[0]=cos(vry*CD)*v2[0]-sin(vry*CD)*v2[1];
    v[1]=+sin(vry*CD)*v2[0]+cos(vry*CD)*v2[1];
    v[2]=v2[2];
    if(k=='+') {cx+=v[0];cy+=v[1];cz+=v[2];}
    else {cx-=v[0];cy-=v[1];cz-=v[2];}
  }
  if(k=='*')
    coef*=1.1;
  if(k=='/')
    coef/=1.1;
  if(k=='a')
    gammaa*=1.1;
  if(k=='z')
    gammaa/=1.1;
  printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  //glutPostRedisplay();
} 

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}

void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

/**************************************/

void draw(void)
{
  int i,j;
  
  r++;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  //glPushMatrix();

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glRotatef(90,0.,0.,1.);
  gluPerspective( /* field of view in degree */ 45.0, /* aspect ratio */ 1.0,
  		  /* Z near */ 0.001, /* Z far */ 4000.0);
  glMatrixMode(GL_MODELVIEW); /* now change to modelview */
  glLoadIdentity();
  //gluLookAt(500, 500.0, 500.0,   /* eye is at (0,0,30) */
  //    0.0, 0.0, 0.0,    /* center is at (0,0,0) */
  //    0.0, 1.0, 0.);    /* up is in postivie Y direction */
  //glPushMatrix();
  
  //glLoadIdentity();
  
  glRotatef(90.+vrx, 0.0, 1.0, 0.0);
  glRotatef(-vry, 0.0, 0.0, 1.0);
  //glRotatef(view_roty, 0.0, 1.0, 0.0);
  
  //glPushMatrix();
  //glTranslatef(-6./md*tmin[0], -6./md*tmin[1], -6./md*tmin[2]-10.0);
  //glTranslatef(-tmin[0], -tmin[1], -tmin[2]-5.0);
  glTranslatef(cx,cy,cz);
  //glScalef(0.01,0.01,0.01);
  
  //glRotatef(angle, 0.0, 0.0, 1.0);
  
  //glPopMatrix();
  
  //glShadeModel(GL_FLAT);
  glShadeModel(GL_SMOOTH);

  /*
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0,1.0,-1.0,1.0,1.,2000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  //glLoadIdentity();

  glRotatef(90., 0.0, 0.0, 1.0);
  
  glRotatef(vrx, 1.0, 0.0, 0.0);
  glRotatef(vry, 0.0, 1.0, 0.0);
  glRotatef(vrz, 0.0, 0.0, 1.0);
  
  //glScalef(0.02,0.02,0.02);
  
  glTranslatef(-cx,cy,-cz);
  //glMultMatrixf(mt); 

  glShadeModel(GL_FLAT);
  */

  for(i=0;i<npoly;i++) {
    if(plain) {
    
      float c=(pow(tpoly[i].rad,gammaa))*coef;
      glColor3d(c,c,c);
      glBegin(GL_POLYGON);
      
      for(j=0;j<tpoly[i].nbr;j++) {
	glVertex3dv(tpoly[i].tab[j]);
      }
      glEnd();
    }
    
    if(wireframe) {
      glColor3d(1.,1.,1.);
      glBegin(GL_LINE_LOOP);
      for(j=0;j<tpoly[i].nbr;j++) {
	glVertex3dv(tpoly[i].tab[j]);
      }
      glEnd();
    }
  }
  
  //glPopMatrix();
  glutSwapBuffers();
  
  //usleep(10000);

  if(r && r%300==0) { 
    long long int t;
    printf("r=%d rate=%f \n",r,300.*CLOCKS_PER_SEC/((t=clock())-otime));
    otime=t;
  }
}  

void init(void)
{

}

void main2(void)
{
  otime=clock();
  
  r=0;
  while(1) {

    draw();
  }
      
}

int main(int argc,char **argv)
{
  char filename[100]="../rad/lala.truc";
  
  if(argc>1) {
    strcpy(filename,argv[1]);
    argc--;
    argv++;
  }
  
  readfile(filename);
  
  /***************/

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
  
  //glutInitWindowPosition(100, 100);
  glutInitWindowSize(600, 600);
  glutCreateWindow("Test");
  init();
  

  /*{
    static GLfloat pos[4] =
    {0.0, 0.0, 0.0, 0.0};
    glLightfv(GL_LIGHT0, GL_POSITION, pos);
    }*/
  glEnable(GL_CULL_FACE);
  //glEnable(GL_LIGHTING);
  //glEnable(GL_LIGHT0);
  //glFrontFace(GL_CW);
  glFrontFace(GL_CCW);
  glEnable(GL_CULL_FACE);
  glCullFace(GL_BACK);

  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS); //LEQUAL);

  glClearColor(0.2,0.2,0.4,0.);

  glPolygonMode(GL_FRONT,GL_FILL);
  glPolygonMode(GL_BACK,GL_LINE);
  //if(!normcull)
  //  glDisable(GL_CULL_FACE);
  //else
  
  
  //glEnable(GL_AUTO_NORMAL);
  glEnable(GL_NORMALIZE);
  
  if (argc > 1 && strcmp(argv[1], "-info")==0) {
    printf("GL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
    printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
    printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
    printf("GL_EXTENSIONS = %s\n", (char *) glGetString(GL_EXTENSIONS));
  }

  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  glutMainLoop();

  return 0;
}

