#include "struct.hpp"
#include "render.hpp"
#include "sil.hpp"
#include "wp.hpp"
#include <GL/gl.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//init :init opengl/fenetre

// FIX
scene_t *scene;

float repeat[] = {GL_REPEAT};
float clamp[] = {GL_CLAMP};
float nr[] = {GL_NEAREST};
float ln[] = {GL_LINEAR};
float nr_mipmap_nr[] = {GL_NEAREST_MIPMAP_NEAREST};
float nr_mipmap_ln[] = {GL_NEAREST_MIPMAP_LINEAR};
float ln_mipmap_nr[] = {GL_LINEAR_MIPMAP_NEAREST};
float ln_mipmap_ln[] = {GL_LINEAR_MIPMAP_LINEAR};
float *magFilter=nr, *sWrapMode=repeat, *tWrapMode=repeat,*minFilter = nr_mipmap_nr;

static unsigned char texturebidon[64][64][4];
static unsigned char texturebidon2[64][64][4];

unsigned int textures[10];

int wplforward=1;

static void gentexturebidon()
{
  int i,j,k;
  for(i=0;i<64;i++)
    for(j=0;j<64;j++) {
      for(k=0;k<4;k++)
	texturebidon[i][j][k]=0;
      texturebidon[i][j][(1+i+j)%4]=64;
    }

  for(i=0;i<64;i++)
    for(j=0;j<64;j++) {
      for(k=0;k<4;k++)
	texturebidon2[i][j][k]=0;
      texturebidon2[i][j][(1+i+j)%4]=192;
    }
}

//init map (textures...)

// prevoir chargement/dechargement zones

//render (position camera)

//end map

//end opengl

bool initdisp()
{
  int i;
  char *toto[]={"toto"};
  glutInit(&i,toto);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE | GLUT_STENCIL);
  
  //glutInitWindowPosition(100, 100);
  glutInitWindowSize(600, 600);
  glutCreateWindow("Test");
  //init();
  
  //glEnable(GL_LIGHTING);
  //glEnable(GL_LIGHT0);

  glEnable(GL_CULL_FACE);
  //glFrontFace(GL_CW);
  glFrontFace(GL_CCW);
  glCullFace(GL_BACK);

  glEnable(GL_DEPTH_TEST);
  //glDepthFunc(GL_LESS);
  glDepthFunc(GL_LEQUAL);

  glClearColor(0.2,0.2,0.4,0.);

  //glPolygonMode(GL_FRONT,GL_FILL);
  //glPolygonMode(GL_BACK,GL_LINE);
  //if(!normcull)
  //  glDisable(GL_CULL_FACE);
  
  //glEnable(GL_AUTO_NORMAL);
  //glEnable(GL_NORMALIZE);

  //glShadeModel(GL_FLAT);
  //glShadeModel(GL_SMOOTH);

  gentexturebidon();

  //glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glGenTextures(2,textures);
  glBindTexture(GL_TEXTURE_2D, textures[0]); 
  gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 64, 64,
		    GL_RGBA, GL_UNSIGNED_BYTE, &texturebidon[0][0][0]);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, sWrapMode);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, tWrapMode);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magFilter);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);

  glBindTexture(GL_TEXTURE_2D, textures[1]); 
  gluBuild2DMipmaps(GL_TEXTURE_2D, 3, 64, 64,
		    GL_RGBA, GL_UNSIGNED_BYTE, &texturebidon2[0][0][0]);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, sWrapMode);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, tWrapMode);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magFilter);
  glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minFilter);
  //glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, decal);
  glEnable(GL_TEXTURE_2D);

  FILE *info=fopen("info_ogl.txt","wt");
  if(info) {
    fprintf(info,"VENDOR: %s\n",glGetString(GL_VENDOR));
    fprintf(info,"RENDERER: %s\n",glGetString(GL_RENDERER));
    fprintf(info,"VERSION: %s\n",glGetString(GL_VERSION));
    fprintf(info,"EXTENSIONS: %s\n",glGetString(GL_EXTENSIONS));
    fclose(info);
  }

  return true;
}

/**************************************/

float vrx=0.0,vry=0.0,vrz=0.0;
//float cx=0.257,cy=0.1243,cz=0.2345;
//float cx=86.151718,cy=-126.108894,cz=39.314568;
//float cpx=86.151718,cpy=-126.108894,cpz=39.314568;
//float cx=-66.015320,cy=85.685043,cz=118.841011;
//float cpx=-66.015320,cpy=85.685043,cpz=118.841011;
float cpx=-893.723450,cpy=893.585327,cpz=-735.756287;
float cx=-893.723450,cy=893.585327,cz=-735.756287;

static void
idle(void)
{
  glutPostRedisplay();
}

static void
special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    vrx+=3;
    break;
  case GLUT_KEY_DOWN:
    vrx-=3;
    break;
  case GLUT_KEY_LEFT:
    vry+=3;
    break;
  case GLUT_KEY_RIGHT:
    vry-=3;
    break;
  default:
    return;
  }
  printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  glutPostRedisplay();
}

static void
key(unsigned char k, int x, int y)
{
#define CD M_PI/180.
  //if(k=='w')
  //  wireframe=1-wireframe;
  //if(k=='p')
  //  plain=1-plain;
  //if(k=='n')
  //  normcull=1-normcull;
  //if(k==' ')
  //  l0=1-l0;
  if(k=='+'|| k=='-') { 
    float v[3]={-0.05*1000.,0.,0.},v2[3];
    v2[1]=v[1];
    v2[0]=cos(vrx*CD)*v[0]-sin(vrx*CD)*v[2];
    v2[2]=sin(vrx*CD)*v[0]+cos(vrx*CD)*v[2];
    v[0]=cos(vry*CD)*v2[0]-sin(vry*CD)*v2[1];
    v[1]=+sin(vry*CD)*v2[0]+cos(vry*CD)*v2[1];
    v[2]=v2[2];
    if(k=='+') {cx+=v[0];cy+=v[1];cz+=v[2];}
    else {cx-=v[0];cy-=v[1];cz-=v[2];}
  }
  //if(k=='*')
  //  coef*=1.1;
  //if(k=='/')
  //  coef/=1.1;
  //if(k=='a')
  //  gammaa*=1.1;
  //if(k=='z')
  //  gammaa/=1.1;
  printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  //glutPostRedisplay();
  if(k=='p') {
    cpx=cx;
    cpy=cy;
    cpz=cz;
  }
  if(k=='o') {
    debsil++;
    printf("debsil=%d\n",debsil);
  }
  if(k=='i') {
    debsil--;
    printf("debsil=%d\n",debsil);
  }
  if(k=='y') {
    FILE *out=fopen("light.wp","at");
    fprintf(out,"%f %f %f\n",cx,cy,cz);
    fclose(out);
  }
  if(k=='u') wplforward=1-wplforward;
} 

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}

void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

void draw(void)
{
  float cam[3],rot[3],ps[3];
  cam[0]=cx;cam[1]=cy;cam[2]=cz;
  rot[0]=vrx;rot[1]=vry;rot[2]=vrz;
  ps[0]=cpx;ps[1]=cpy;ps[2]=cpz;

  renderscene(scene,cam,rot,ps);

  glutSwapBuffers();

}
/**************************************/


void mainloop()
{
  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);
  glutIdleFunc(idle);

  glutMainLoop();
}

void initmap(map_t *m)
{
  scene=m;

  //FIX
  wpl.load("light.wp");

  glVertexPointer(3,GL_FLOAT,sizeof(vertex_t),&m->ve[0].pos[0]);
  //glNormalPointer(3,GL_FLOAT,sizeof(vertex_t),&m->ve[0].norm[0]);
  glTexCoordPointer(2,GL_FLOAT,sizeof(vertex_t),&m->ve[0].texpos[0]);
  glEnableClientState(GL_VERTEX_ARRAY);  
  //glEnableClientState(GL_NORMAL_ARRAY);  
  glEnableClientState(GL_TEXTURE_COORD_ARRAY);  

}



