#include "struct.hpp"
#include "render.hpp"
#include "sil.hpp"
#include "wp.hpp"

#include <stdio.h>

#include <GL/gl.h>
#include <GL/glu.h>

int r_drawlines=0;
int r_drawpolys=1;
int r_drawsil=0;
int r_drawsilplain=0;
int r_drawshadow=1; // stencil 

//static float Cam[3],Rot[3];

sil_t sil;

static void affleaf(scene_t *s,int j)
{
  if(r_drawpolys) {
    glBindTexture(GL_TEXTURE_2D,textures[0]);
    for(int i=0;i<s->bl[j].nbrface;i++)
      //if((s->fa[s->bl[j].face+i].flag&1)){
      glDrawArrays(GL_POLYGON,s->fa[s->bl[j].face+i].vertex,s->fa[s->bl[j].face+i].nbrvertex);
  }

  if(r_drawlines) {
    glColor3f(1.,1.,1.);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_TEXTURE_2D);
    
    //FIX
    for(int i=0;i<s->bl[j].nbrface;i++)
      glDrawArrays(GL_LINE_LOOP,s->fa[s->bl[j].face+i].vertex,s->fa[s->bl[j].face+i].nbrvertex);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
  }
}

static void affleaf_shad(scene_t *s)
{
  glBindTexture(GL_TEXTURE_2D,textures[1]);
  //glDisable(GL_TEXTURE_2D);
  //glColor3f(0.5,0.5,0.5);
  glEnable(GL_STENCIL_TEST);
  if(sil.cameravis)
    glStencilFunc(GL_EQUAL,0,1);
  else
    glStencilFunc(GL_EQUAL,1,1);
  glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);

  for(int j=1;j<s->nbl;j++)
    for(int i=0;i<s->bl[j].nbrface;i++)
      glDrawArrays(GL_POLYGON,s->fa[s->bl[j].face+i].vertex,s->fa[s->bl[j].face+i].nbrvertex);

  glDisable(GL_STENCIL_TEST);
  //glEnable(GL_TEXTURE_2D);
}

static void affsil(scene_t *s,sil_t &sil)
{  
  if(r_drawsil && sil.sil!=NULL) {
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_TEXTURE_2D);

    //int ii=0;
    for(int j=0;j<sil.nbrsil;j++) {
      int i=sil.siltab[j];
      do{
	if(!(sil.sil[i].flag&SILELMVIS))
	  glColor3f(1.,0.5,0.5);
	else {
	  if(sil.sil[i].flag & SILELMMARK)
	    glColor3f(0.,1.,0.);
	  else 
	    glColor3f(0.,0.,1.);
	  
	  if(sil.sil[i].flag&SILELMDEB)
	    glColor3f(0.,0.,0.);
	}
	{
	  /*
	  ii=(ii+1)%3;
	  float c[3];
	  c[0]=c[1]=c[2]=0.;
	  c[ii]=1.;
	  glColor3fv(c);
	  */

	  glBegin(GL_LINES);
	  glVertex3fv(sil.sil[i].pos);
	  glVertex3fv(sil.sil[sil.sil[i].next].pos);
	  glEnd();

	  if((sil.sil[i].flag&SILELMVIS) && (sil.sil[i].flag&SILELMMARK)) {
	    int j=i;
	    if(sil.sil[i].flag & SILELMCROSS &&
	       sil.sil[sil.sil[i].cross].flag & SILELMVIS)  {
	      if(sil.sil[i].flag & SILELMENTER && sil.sil[i].flag & SILELMFIRST)
		j=sil.sil[i].cross;
	    }

	    //if(sil.sil[i].flag&SILELMPROJ)
	    //  glColor3f(0.,0.,0.);
	    //else
	    glColor3f(1.,1.,1.);
	    glBegin(GL_LINES);
	    glVertex3fv(sil.sil[i].pos);
	    glVertex3fv(sil.sil[j].proj);
	    glEnd();

	    int in=sil.sil[i].next,jn=in;;
	    if(sil.sil[in].flag & SILELMENTER)
	      if(sil.sil[sil.sil[in].cross].flag & SILELMVIS) {
		jn=sil.sil[in].cross;
	      }
	    
	    glColor3f(1.,0.,0.);
	    glBegin(GL_LINES);
	    glVertex3fv(sil.sil[i].proj);
	    glVertex3fv(sil.sil[in].proj);
	    glEnd();
	    

	    if(r_drawsilplain) {
	      glEnable(GL_DEPTH_TEST);
	      glDisable(GL_CULL_FACE);
	      glColor3f(0.5,0.5,0.5);
	      glBegin(GL_POLYGON);
	      glVertex3fv(sil.sil[i].pos);
	      glVertex3fv(sil.sil[j].proj);
	      glVertex3fv(sil.sil[jn].proj);
	      glVertex3fv(sil.sil[in].pos);
	      glEnd();
	      glDisable(GL_DEPTH_TEST);
	      glEnable(GL_CULL_FACE);
	    }
	  }
	}
	i=sil.sil[i].next;
      } while(i!=sil.siltab[j]);
    }
    glColor3f(1.,1.,1.);

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);

  }

  if(r_drawshadow && sil.sil!=NULL) {

    glDepthMask(GL_FALSE);
    glEnable(GL_DEPTH_TEST);
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_CULL_FACE);
    int buff;
    glGetIntegerv(GL_DRAW_BUFFER,&buff);
    glDrawBuffer(GL_NONE);
    glEnable(GL_STENCIL_TEST);
    glColor3f(1.,1.,1.);
    glStencilFunc(GL_ALWAYS,0,0);
    glStencilOp(GL_KEEP,GL_KEEP,GL_INCR);

    glClearStencil(0);
    glClear(GL_STENCIL_BUFFER_BIT);
    
    for(int j=0;j<sil.nbrsil;j++) {
      int i=sil.siltab[j];
      do{
	if((sil.sil[i].flag&SILELMVIS) && (sil.sil[i].flag&SILELMMARK)) {

	  int in=sil.sil[i].next,j=i,jn=in;
	  
	  if(sil.sil[in].flag & SILELMCROSS &&
	     sil.sil[sil.sil[in].cross].flag & SILELMVIS)  {
	    if(sil.sil[in].flag & SILELMENTER && sil.sil[in].flag & SILELMFIRST)
	      jn=sil.sil[in].cross;
	  }

	  if(sil.sil[i].flag & SILELMCROSS &&
	     sil.sil[sil.sil[sil.sil[i].cross].prev].flag & SILELMVIS)  {
	    if(!(sil.sil[i].flag & SILELMENTER) && sil.sil[i].flag & SILELMFIRST)
	      j=sil.sil[i].cross;
	  }

	  
	  glColor3f(1.,0.5,0.5);
	  glBegin(GL_POLYGON);
	  // FIX tjunc
	  glVertex3fv(sil.sil[i].pos);
	  glVertex3fv(sil.sil[j].proj);
	  glVertex3fv(sil.sil[jn].proj);
	  //glVertex3fv(sil.sil[in].pos);
	  glVertex3fv(sil.sil[in].pos);
	  glEnd();
	}
	i=sil.sil[i].next;
      } while(i!=sil.siltab[j]);
    }
    glColor3f(1.,1.,1.);
    
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_CULL_FACE);
    glDrawBuffer(buff);
    glDisable(GL_STENCIL_TEST);
    glDepthMask(GL_TRUE);
  }
}

void renderscene(scene_t *s,float cam[3],float rot[3],float ps[3])
{
  //vec3Copy(cam,Cam);
  //vec3Copy(rot,Rot);

  //glDepthRange(0.,1000.);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glRotatef(90,0.,0.,1.);
  gluPerspective( /* field of view in degree */ 45.0, /* aspect ratio */ 1.0,
  		  /* Z near */ 0.001, /* Z far */ 4000.0);

  glMatrixMode(GL_MODELVIEW); /* now change to modelview */
  glLoadIdentity();

  glRotatef(90.+rot[0], 0.0, 1.0, 0.0);
  glRotatef(-rot[1], 0.0, 0.0, 1.0);
  //glRotatef(view_roty, 0.0, 1.0, 0.0);
  
  glScalef(0.001,0.001,0.001);
  glTranslatef(cam[0],cam[1],cam[2]);
  
  //glRotatef(angle, 0.0, 0.0, 1.0);
  
  //glShadeModel(GL_FLAT);
  //glShadeModel(GL_SMOOTH);



  float pp[3];

  if(wplforward)
    wpl.forward(30.,pp);
  else 
    wpl.forward(0.,pp);

  float p[3]={-pp[0],-pp[1],-pp[2]};

  sil.computesil(s,p,0);

  float pc[3]={-cam[0],-cam[1],-cam[2]};
  sil.camera(pc);

  for(int i=1;i<s->nbl;i++)
    affleaf(s,i);

  affsil(s,sil);

  if(r_drawshadow && r_drawpolys)
    affleaf_shad(s);
}
