#include "struct.hpp"
#include "vect.hpp"
#include "sil.hpp"
#include "utils.hpp"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#define DEBSILPROJ

/**********
(probleme: apres les cut pour l'intersect, il va recutter) -> tabi
utilisation de tabi: il faut fixer ca...
trouver autre algo pour intersect sans tabi et robuste

pour project, ne jamais passer sur face non visible


PROFILING: testintersect_ prend presque tout le temps


***********/

int debsil=0,debsil_=0;

inline int sil_t::allocsilelm()
{
  if(silfree!=-1) {
    int i=silfree;
    silfree=sil[silfree].next;
    return i;
  } else {
    printf("Erreur FIX\n");
    exit(1);
  }
}

inline void sil_t::deallocsilelm(int i)
{
  sil[i].next=silfree;
  silfree=i;
}

/*******************************/

#define NEXT(j) {if(j==s->fa[s->ve[j].face].vertex+s->fa[s->ve[j].face].nbrvertex-1) j=s->fa[s->ve[j].face].vertex; else j++;}
#define OP(j) {j=s->fa[s->ve[j].faceop&((1<<24)-1)].vertex+s->ve[j].indop;}

/********* test visibilitee ******/

bool sil_t::testvis_r(int bsp,const vec3_t a,const vec3_t b)
{
  if(bsp>0) {
    if((s->bl[bsp].flag)&LEAFBLOCK) 
      return false;
    return true;
  } else {
    bsp=-bsp;
    int da=checkvertex(s,a,s->bi[bsp].plane);
    int db=checkvertex(s,b,s->bi[bsp].plane);
    if(da==0 && db==0) return testvis_r(s->bi[bsp].child[0],a,b) 
			 || testvis_r(s->bi[bsp].child[1],a,b);
    if(da>=0 && db >=0) return testvis_r(s->bi[bsp].child[0],a,b);
    else if(da<=0 && db <=0) return testvis_r(s->bi[bsp].child[1],a,b);
    else {
      vec3_t c;
      intersectplane(s,s->bi[bsp].plane,a,b,c);
      if(da>0) return testvis_r(s->bi[bsp].child[0],a,c) &&
		 testvis_r(s->bi[bsp].child[1],c,b);
      else return testvis_r(s->bi[bsp].child[0],b,c) &&
	     testvis_r(s->bi[bsp].child[1],c,a);
    }
  }
}

bool sil_t::testvis(vec3_t v)
{
  return testvis_r(-1,pos,v);
} 

/*******************/

void sil_t::printflag(int i)
{
  printf("%d: ",i);
  if(sil[i].flag & SILELMVIS) printf("VIS ");
  if(sil[i].flag & SILELMSTART) printf("START");
  if(sil[i].flag & SILELMSTOP) printf("STOP");
  if(sil[i].flag & SILELMCROSS) {
    printf("CROSS ");
    if(sil[i].flag & SILELMFIRST) printf("FIRST ");
    if(sil[i].flag & SILELMENTER) printf("ENTER ");
  }
  printf("\n");fflush(stdout);
}

void sil_t::printsil(int i)
{
  printf("sil[%d]: n=%d p=%d c=%d\n",i,sil[i].next,sil[i].prev,sil[i].cross);
}

// >=0: face
// -1: visible 
// -2: block
int sil_t::projectbsp_r(vec3_t a,vec3_t b,vec3_t proj,bool vect,int bsp,int &last)
{
  if(bsp>0) {
    last=bsp;
    if((s->bl[bsp].flag)&LEAFBLOCK) 
      return -2;
    return -1;
  } else {
    int pl=s->bi[-bsp].plane;
    int da,db,f,foo;
    vec3_t v,c;
    vec_t r;

    da=checkvertex(s,a,pl);
    if(!vect)
      db=checkvertex(s,b,pl);
    else {
      if(pl>0) r=vec3DotProduct(b,s->pl[pl].n);
      else  r=-vec3DotProduct(b,s->pl[-pl].n);
      if(r>=0) db=1;
      else db=-1;
    }

    if(da>=0 && db>=0) {
      return projectbsp_r(a,b,proj,vect,s->bi[-bsp].child[0],last);
    }
    if(da<=0 && db<=0) {
      return projectbsp_r(a,b,proj,vect,s->bi[-bsp].child[1],last);
    }

    if(da==1 && db==-1)
      f=0;
    else f=1;

    if(!vect)
      intersectplane(s,s->bi[-bsp].plane,a,b,c);
    else {
      vec3Copy(a,v);
      vec3Add_(b,v);
      intersectplane(s,s->bi[-bsp].plane,a,v,c);
    }
    int d=projectbsp_r(a,c,proj,false,s->bi[-bsp].child[f],last);
    if(d>=0 || d==-2) return d;
    d=projectbsp_r(c,b,proj,vect,s->bi[-bsp].child[1-f],foo);
    if(d>=0) return d;
    if(d==-1) {
      last=foo;
      return d;
    }

    //d==-2
    vec3Copy(c,proj);
    for(int i=0;i<s->bl[last].nbrface;i++) {
      int face=s->bl[last].face+i;
      //FIX virer abs()
      if(abs(s->fa[face].plane)==abs(pl)) {
	vec4_t pl2;
	int j;
	for(j=0;j<s->fa[face].nbrvertex;j++) {
	  int jj=j+1;
	  if(jj==s->fa[face].nbrvertex) jj=0;
	  vec3Copy(s->ve[s->fa[face].vertex+j].pos,v);
	  vec3Sub_(s->ve[s->fa[face].vertex+jj].pos,v);
	  if(s->fa[face].plane>0) {
	    vec3CrossProduct(v,s->pl[s->fa[face].plane].n,pl2);
	  } else {
	    vec3CrossProduct(v,s->pl[-s->fa[face].plane].n,pl2);
	    vec4Scale_(-1,pl2);
	  }
	  pl2[3]=-vec3DotProduct(pl2,s->ve[s->fa[face].vertex+j].pos);
	  if(checkvertex(s,c,pl2)<0) break;
	}
	if(j==s->fa[face].nbrvertex) {
	  return face;
	}
      }
    }

    printf("Erreur face pas trouve dans projectbsp\n");
    exit(1);
    return d;
  }
}

int sil_t::projectbsp(int i,vec3_t proj)
{
  vec3_t v;
  vec3Copy(sil[i].pos,v);
  vec3Sub_(pos,v);
  int l;
  return projectbsp_r(sil[i].pos,v,proj,true,-1,l);
}

////////

//renvoie face de nouveau v;
//proj sera la nouvelle projection
int sil_t::project(int i,int face,vec3_t proj,int oldface) 
{
  sil[i].flag |= SILELMMARK;

  debsil_++;
  //if(debsil_>=debsil) return -1;

  if(face<0) return face;

  if(!(s->fa[face].flag&mask)) {
    printf("PAS VISIBLE !!!\n");
    //exit(1);
    return -1;
  }

  int j,vop;
  int p;
  vec3_t u,v;
  vec4_t pl;

  p=s->fa[face].plane;
  if(p<0) p=-p;
  vop=sil[i].v;
  OP(vop);
  
  vec3Copy(s->ve[sil[i].v].pos,u);
  vec3Sub_(pos,u);
  vec3Copy(s->ve[vop].pos,v);
  vec3Sub_(pos,v);
  vec3CrossProduct(u,v,pl);
  pl[3]=-vec3DotProduct(pos,pl);

#ifdef DEBSILPROJ
  printf("---PROJ--- (%d) i=%d face=%d\n",debsil_,i,face);
  printf("pos=");vec3Print(pos);
  printf("\nve[i]=");vec3Print(s->ve[sil[i].v].pos);
  printf("\nve[i].op=");vec3Print(s->ve[vop].pos);
  printf("\ni.pos=");vec3Print(sil[i].pos);
  printf("\ni.next.pos=");vec3Print(sil[sil[i].next].pos);
  printf("\ni.proj=");vec3Print(sil[i].proj);printf("\n");
  printf("plane %f %f %f %f\n",pl[0],pl[1],pl[2],pl[3]);
#endif

  int jeq=-1;
  int jj;
  bool c,ci,co;

  for(j=0;j<=s->fa[face].nbrvertex;j++) {

    // FIX faire dans tous les cas en cas d'egalite
    if(vec3Equal(sil[i].pos,s->ve[s->fa[face].vertex+j].pos)) {
#ifdef DEBSILPROJ
      printf("vertex == %d\n",j);
#endif
      jeq=j;
    }

    //FIX vec3Equal i.next.pos == he ?

    if(j!=s->fa[face].nbrvertex) {
      vec_t r=vec3DotProduct(s->ve[s->fa[face].vertex+j].pos,pl)+pl[3];
      c=(r>0.);
#ifdef DEBSILPROJ
      printf("%d: %f ",j,r);vec3Print(s->ve[s->fa[face].vertex+j].pos);
      printf("\n");
#endif
    } else c=ci;
    if(j==0) ci=c;
    
    if(j) {
      if(c==false && co==true) {
	j--;
	break;
      }
    }
    co=c;
  }

  if(j>=s->fa[face].nbrvertex) { 
    if(jeq==-1) {
      printf("Erreur project trouve hedge\n");
      exit(1);return -1;
    }
    if(c==false) j=jeq;
    else {
      j=jeq-1;
      if(j==-1) j=s->fa[face].nbrvertex;
    }
    int nf=s->ve[s->fa[face].vertex+j].faceop&((1<<24)-1);
#ifdef DEBSILPROJ
    printf("non resolu nf=%d",nf);
#endif
    return project(i,nf,proj,face);
  }

  jj=j+1;
  if(jj==s->fa[face].nbrvertex) jj=0;

  vec4_t pl2;
  vec3Copy(s->ve[s->fa[face].vertex+j].pos,u);
  vec3Sub_(pos,u);
  vec3Copy(s->ve[s->fa[face].vertex+jj].pos,v);
  vec3Sub_(pos,v);
  vec3CrossProduct(u,v,pl2);
  pl2[3]=-vec3DotProduct(pos,pl2);

  vec_t r=vec3DotProduct(pl2,sil[sil[i].next].pos)+pl2[3];

#ifdef DEBSILPROJ
  printf("j=%d\n",j);
  printf("he=");vec3Print(s->ve[s->fa[face].vertex+j].pos);
  printf("\nhe.next=");vec3Print(s->ve[s->fa[face].vertex+jj].pos);
  printf("\nplane2 %f %f %f %f\n",pl2[0],pl2[1],pl2[2],pl2[3]);
  printf("r=%f\n",r);
#endif

  if(r<0.) {
    // si dans face, calcul proj et return 
    vec3Copy(sil[sil[i].next].pos,proj);
    vec3Sub_(pos,proj);
    vec_t t=(-s->pl[p].n[3]-vec3DotProduct(pos,s->pl[p].n))/vec3DotProduct(proj,s->pl[p].n);
    vec3Scale_(t,proj);
    vec3Add_(pos,proj);
    
#ifdef DEBSILPROJ
    printf("in: proj=");vec3Print(proj);printf("\n");
#endif
    
    return face;
  } else {
    //int nf=s->ve[s->fa[face].vertex+j].faceop;
    int nf=s->ve[s->fa[face].vertex+j].faceop&((1<<24)-1);    
    
    int i2=allocsilelm();
    sil[i2].prev=i;
    sil[i2].next=sil[i].next;
    sil[sil[i].next].prev=i2;
    sil[i].next=i2;

    intersectplane(s,pl,s->ve[s->fa[face].vertex+j].pos,
		   s->ve[s->fa[face].vertex+jj].pos,sil[i2].proj);
   
    intersectplane(s,pl2,s->ve[sil[i].v].pos,
		   s->ve[vop].pos,sil[i2].pos);

#ifdef DEBSILPROJ
    printf("\nnf=%d\n",nf);
    printf("\ncut=");vec3Print(sil[i2].proj);printf("\n");
#endif 
    
    sil[i2].flag=SILELMVIS | SILELMBACK;
    sil[i2].v=sil[i].v;
    sil[i2].so=sil[i].so;

    // si face trouvee== oldface, systeme D (erreur dans un premier temps)
    if(nf==face) {
      printf("Erreur tourne en rond\n");
      exit(1);
    }

    return project(i2,nf,proj,face);
  }
}

void sil_t::floodsilproj_r(int i,int face)
{
  vec3_t proj;
  if(sil[i].flag & SILELMMARK) {
    if(sil[i].flag & SILELMPROJ) 
      return;
    printf("Erreur deja marke\n");
    exit(1);
    return;
  }

  if(!(sil[i].flag & SILELMVIS)) {
    printf("Erreur flood vis %d\n",i);
    exit(1);
    sil[i].flag |=SILELMDEB;
    return;
  }
  int j=sil[i].next;
  int nf=project(i,face,proj);
  if(sil[j].flag & SILELMSTOP) { 
    //printf("FIN STOP\n");
    sil[j].face=nf;
    vec3Copy(sil[j].pos,sil[j].proj);
  }
  else if((sil[j].flag & (SILELMCROSS | SILELMFIRST | SILELMENTER))
	  == (SILELMCROSS | SILELMFIRST) && 
	  (sil[sil[sil[j].cross].prev].flag & SILELMVIS)) { 
    //printf("FIN CROSS FIRST\n");
    //j=sil[j].cross;
    sil[j].face=nf;
    //vec3Copy(proj,sil[j].proj);
    //FIX on connais la face aussi
    vec3Copy(sil[sil[j].cross].pos,sil[j].proj);
  }
  else {
    /*
    if((sil[j].flag & (SILELMCROSS | SILELMENTER))
       == SILELMCROSS) { 
      printf("Erreur flood non enter\n");
    }
    */

    if((sil[j].flag & SILELMCROSS && !(sil[sil[j].cross].flag & SILELMVIS))  
       || !(sil[j].flag & SILELMCROSS)) {
      //tout droit
      sil[j].face=nf;
      if(nf>=0)
	vec3Copy(proj,sil[j].proj);
    } else {
      //intersection primaire

      if(sil[j].flag & SILELMFIRST) {
	
      } else {
	sil[j].face=nf;
	if(nf>=0)
	  vec3Copy(proj,sil[j].proj);
      }

      if(sil[j].flag & SILELMENTER && sil[sil[j].cross].flag & SILELMVIS) {
	j=sil[j].cross;
      } else 
	{ printf("BUG!!!\n");printflag(j);printflag(sil[j].cross);}
      
      if(sil[j].flag & SILELMFIRST) {
      } else {
	sil[j].face=nf;
	if(nf>=0)
	  vec3Copy(proj,sil[j].proj);
      }
    }
    //printf("sil[%d].proj=",j);vec3Print(proj);printf("\n");
    
    floodsilproj_r(j,nf);
  }
}

void sil_t::floodsilproj(int i)
{
  //printf("flood\n");
  if(sil[i].flag & SILELMSTART) {
    vec3Copy(sil[i].pos,sil[i].proj);
    int j=sil[sil[i].prev].v;;
    int face=s->ve[j].face;
    if(!(s->fa[face].flag & mask)) {
      OP(j);
      face=s->ve[j].face;
    }
    sil[i].face=face;
    //printf("START\n");
    floodsilproj_r(i,face);
  } else if((sil[i].flag & (SILELMCROSS | SILELMFIRST | SILELMENTER))
	    == (SILELMCROSS | SILELMFIRST | SILELMENTER))
    {
      vec3Copy(sil[sil[i].cross].pos,sil[i].proj);
      sil[i].face=s->ve[sil[sil[i].cross].v].face;
      //printf("CROSS FIRST ENTER\n");
      floodsilproj_r(i,sil[i].face);
    }
  else {
    printf("Erreur flood\n");
  }
}


/*************/

void sil_t::cutsilelm(int &j,int &j1,int &j2,vec_t pj[3],int &ss)
{
  j1=allocsilelm();
  j2=allocsilelm();
  //printf("cut %d %d %d\n",j,j1,j2);
  
  // next prev
  sil[j1].next=j2;
  sil[j2].next=sil[j].next;
  sil[j2].prev=j1;
  sil[j1].prev=sil[j].prev;
  sil[sil[j].prev].next=j1;
  sil[sil[j].next].prev=j2;

  vec3Copy(sil[j].pos,sil[j1].pos);
  vec3Copy(pj,sil[j2].pos);
  //vec3Copy(sil[j].pos,sil[j2].pos);

  sil[j2].v=sil[j1].v=sil[j].v;
  
  sil[j1].flag=sil[j].flag;
  sil[j2].flag=0;
  sil[j2].flag|=SILELMCROSS;
  sil[j1].cross=sil[j].cross;
  if(sil[j].flag & SILELMCROSS) {
    sil[sil[j].cross].cross=j1;
  }

  sil[j1].so=sil[j2].so=sil[j].so;

  if(siltab[ss]==j) siltab[ss]=j1;
}

bool sil_t::testintersect_(int &i,int &si,char *tabi)
{
  int j;
  int vo=sil[i].v;
  vec_t n[4];
  vec_t u[3],v[3];
  vec_t n2[4];

  // on utilise vertex pour que le plan soit valide
  // FIX gerer le cas ou les 3 points sont colineaires
  OP(vo);
  vec3Copy(s->ve[sil[i].v].pos,u);
  vec3Copy(s->ve[vo].pos,v);
  vec3Sub_(pos,u);
  vec3Sub_(pos,v);
  vec3CrossProduct(u,v,n);
  n[3]=-vec3DotProduct(n,pos);

  int jj;
  for(jj=0;jj<nbrsil;jj++) {
    j=siltab[jj];
    if(i==j) return false;
    do{
      int ok=0;
      //printf("%d %d\n",sil[i].so,sil[j].so);
      if(tabi[sil[i].so*nbrhesil+sil[j].so]==0) ok=1;
      if(i==j || i==sil[j].next || i==sil[j].prev) ok=0;
      if((sil[i].flag & SILELMCROSS) && 
	 (sil[i].cross==j || sil[i].cross==sil[j].next)) ok=0;
      if((sil[j].flag & SILELMCROSS) && (sil[j].cross==sil[i].next)) ok=0;
      if((sil[sil[i].next].flag & SILELMCROSS) && 
	 (sil[sil[i].next].cross==sil[j].next)) ok=0;
      
      if(ok) {
	int k=sil[j].next;
	vec_t d=vec3DotProduct(n,sil[j].pos)+n[3];
	vec_t d2=vec3DotProduct(n,sil[k].pos)+n[3];
	// FIX probleme si == 0. (au coup d'apres plan n'est pas valide)
	// le plan sera OK car utilisation de s->ve
	if(d==0.) d=1.;
	if(d2==0.) d2=1.;
	if((d<0.) ^ (d2<0.)) {
	  // l'autre test
	  int vo2=sil[j].v;
	  OP(vo2);
	  vec3Copy(s->ve[sil[j].v].pos,u);
	  vec3Copy(s->ve[vo2].pos,v);
	  vec3Sub_(pos,u);
	  vec3Sub_(pos,v);
	  vec3CrossProduct(u,v,n2);
	  n2[3]=-vec3DotProduct(n2,pos);
	  
	  k=sil[i].next;
	  d=vec3DotProduct(n2,sil[i].pos)+n2[3];
	  d2=vec3DotProduct(n2,sil[k].pos)+n2[3];
	  if(d==0.) d=1.;
	  if(d2==0.) d2=1.;
	  if((d<0.) ^ (d2<0.)) {
	    vec3_t pi,pj;
	    
	    // calcul des nouveaux points
	    intersectplane(s,n2,s->ve[sil[i].v].pos,s->ve[vo].pos,pi);
	    intersectplane(s,n,s->ve[sil[j].v].pos,s->ve[vo2].pos,pj);
	    //printf("%f %f %f\n",pi[0],pi[1],pi[2]);	
	    //printf(" %f %f %f\n",pj[0],pj[1],pj[2]);
	    
	    vec3Copy(pi,u);
	    vec3Sub_(pos,u);
	    vec3Copy(pj,v);
	    vec3Sub_(pos,v);
	    if(vec3DotProduct(u,v)>0.) {
	      int i1,i2,j1,j2;
	      vec_t li,lj;

	      li=vec3DotProduct(u,u);
	      lj=vec3DotProduct(v,v);
	      
	      //FIX
	      if(tabi[sil[j].so*nbrhesil+sil[i].so])
		printf("deja: i.n=%d j.n=%d\n",sil[i].next,sil[j].next);

	      tabi[sil[i].so*nbrhesil+sil[j].so]=1;
	      tabi[sil[j].so*nbrhesil+sil[i].so]=1;
	      
	      nbrintersect++;
	      
	      cutsilelm(i,i1,i2,pi,si);
	      cutsilelm(j,j1,j2,pj,jj);
	      
	      sil[j2].cross=i2;
	      sil[i2].cross=j2;

	      if(li<lj) sil[i2].flag|=SILELMFIRST;
	      else sil[j2].flag|=SILELMFIRST;

	      // FIX
	      if(d>0.)
		sil[i2].flag |= SILELMENTER;
	      else
		sil[j2].flag |= SILELMENTER;
	      
	      deallocsilelm(i);
	      deallocsilelm(j);
	      i=i1;
	      
	      return true;
	    }
	  }
	}
      }
      j=sil[j].next;
    } while(j!=siltab[jj]);
  }
  return false;
}

/****** MAIN ******/

void sil_t::computesil(scene_t *s_,vec3_t pos_,int lum)
{
  s=s_;
  vec3Copy(pos_,pos);

  debsil_=0;

  mask=(FLAGSIL<<lum);

  nbrhesil=0;
  nbrintersect=0;

  printf("SIL\n");

  part_sil();
  part_createstr();
  part_intersect();
  part_vis();
  part_proj();

  free(tabi);

  //exit(1);
  printf("\\SIL\n");
  fflush(stdout);
}

void sil_t::part_sil()
{
  int i,j;

  /******** 1: trouve les he dans la silhouete ********/

  for(i=1;i<s->npl;i++) {
    if(vec3DotProduct(s->pl[i].n,pos)+s->pl[i].n[3] >0.)
      s->pl[i].flag|=mask;
    else 
      s->pl[i].flag&=~mask;
  }
  
  //pour toutes les faces
  for(i=0;i<s->nfa;i++) {
    int pl=s->fa[i].plane;
    if((pl>0 && (s->pl[pl].flag&mask)) ||
       (pl<0 && !(s->pl[-pl].flag&mask))) {
      s->fa[i].flag|=mask;
    }
    else 
      s->fa[i].flag&=~mask;
  }

  //pour toutes les faces
  for(i=0;i<s->nfa;i++) {
    if(s->fa[i].flag & mask)
      for(j=0;j<s->fa[i].nbrvertex;j++) {
	int n=s->ve[s->fa[i].vertex+j].faceop;
	//FIX
	n&=(1<<24)-1;
	if(!(s->fa[n].flag&mask)) {
	  s->ve[s->fa[i].vertex+j].flag|=mask;
	  s->ve[s->fa[i].vertex+j].flag&=~VERTEXMARK;
	  nbrhesil++;
	} else
	  s->ve[s->fa[i].vertex+j].flag&=~mask;
      }
    else
      for(j=0;j<s->fa[i].nbrvertex;j++)
	s->ve[s->fa[i].vertex+j].flag&=~mask;
  }

}

void sil_t::part_createstr()
{
  int i;

  /******** 2: creation de la structure ********/

  if(sil) free(sil);
  //FIX
  silsize=nbrhesil+1000;
  sil=(silelm_t*)malloc(sizeof(silelm_t)*silsize);
  nbrhesil2=nbrhesil;
  nbrhesil=0;
  nbrsil=0;
  
  for(i=0;i<s->nve;i++) 
    if(s->ve[i].flag&mask && !(s->ve[i].flag&VERTEXMARK)) {
      int j=i;
      int ns=nbrhesil;
      siltab[nbrsil]=ns;
      nbrsil++;
      do{
	sil[nbrhesil].so=nbrhesil;
	sil[nbrhesil].v=j;
	sil[nbrhesil].next=nbrhesil+1;
	sil[nbrhesil].prev=nbrhesil-1;
	s->ve[j].flag|=VERTEXMARK;
	nbrhesil++;
	NEXT(j);
	while(!(s->ve[j].flag&mask)){
	  OP(j);NEXT(j);
	}
      }while(!(s->ve[j].flag&VERTEXMARK));
      sil[nbrhesil-1].next=ns;
      sil[ns].prev=nbrhesil-1;
    }

  if(nbrhesil!=nbrhesil2) printf("Erreur %d != %d\n",nbrhesil2,nbrhesil);

#undef OP
#undef NEXT

  for(i=0;i<nbrhesil;i++) {
    sil[i].flag=0;
    vec3Copy(s->ve[sil[i].v].pos,sil[i].pos);
  }  

  if(nbrhesil==silsize) silfree=-1;
  else {
    silfree=nbrhesil;
    for(i=nbrhesil;i<silsize;i++)
      sil[i].next=i+1;
    sil[silsize-1].next=-1;
  }

#if 0
  for(j=0;j<nbrsil;j++) {
    printf("sil %d:\n",j);
    i=siltab[j];
    do {
      printf("%d ",i);
      i=sil[i].next;
    } while(i!=siltab[j]);
    printf("\n");
  }
#endif
}

void sil_t::part_intersect()
{
  int i,j;
  /******** 3: intersections ********/

  tabi=(char*)malloc(nbrhesil*nbrhesil);
  bzero(tabi,nbrhesil*nbrhesil);

#if 1
  for(j=0;j<nbrsil;j++) {
    i=siltab[j];
    do {
      if(!testintersect_(i,j,tabi)){
	i=sil[i].next;
      }
    } while(i!=siltab[j]);
  }

  printf("%d he / %d hesil / %d intersect\n",s->nve,nbrhesil,nbrintersect);
#endif
}

void sil_t::part_vis()
{
  int i,j;
  
  /******** 4: elms visibles ********/

#if 1
  //FIX faire des floods
  for(j=0;j<nbrsil;j++) {
    i=siltab[j];
    bool vi,vs;
    do {
      vec3_t v;
      vec3Copy(sil[i].pos,v);
      vec3Add_(sil[sil[i].next].pos,v);
      vec3Scale_(0.5,v);
      if(testvis(v)) {
	sil[i].flag|=SILELMVIS;
	if(i!=siltab[j]) {
	  if(vi==false && !(sil[i].flag&SILELMCROSS)) 
	    sil[i].flag|=SILELMSTART; 
	} else vs=true;
	vi=true;
      } else {
	if(i!=siltab[j]) {
	  if(vi==true && !(sil[i].flag&SILELMCROSS)) 
	    sil[i].flag|=SILELMSTOP; 
	} else vs=false;
	vi=false;
      }
      i=sil[i].next;
    } while(i!=siltab[j]);
    if(vs) {
      if(vi==false && !(sil[i].flag&SILELMCROSS)) sil[i].flag|=SILELMSTART; 
    } else {
      if(vi==true && !(sil[i].flag&SILELMCROSS)) sil[i].flag|=SILELMSTOP; 
    }
  }
#endif
}

void sil_t::part_proj()
{
int i,j;
  /******** 5: projections ********/

#if 1
  for(j=0;j<nbrsil;j++) {
    i=siltab[j];
    do {
      if(sil[i].flag & SILELMVIS && !(sil[i].flag & SILELMMARK)) {
	if(sil[i].flag & SILELMSTART) 
	  floodsilproj(i);
	if((sil[i].flag & (SILELMCROSS | SILELMFIRST | SILELMENTER))
	   == (SILELMCROSS | SILELMFIRST | SILELMENTER)) 
	  if(sil[sil[i].cross].flag & SILELMVIS) {
	    floodsilproj(i);
	  }
      }
      i=sil[i].next;
    } while(i!=siltab[j]);
  }
#endif

#if 1
  // FIX
  //calculer les projections pour ceux pas marques
  for(j=0;j<nbrsil;j++) {
    i=siltab[j];
    do {
      if(!(sil[i].flag & SILELMMARK) && (sil[i].flag & SILELMVIS)) {
	sil[i].flag |= SILELMPROJ;	
	//printf("proj: ");printflag(i);
	vec3_t proj;
	int face=projectbsp(i,proj);
	vec3Copy(proj,sil[i].proj);
	//sil[i].flag |= SILELMMARK;	
	floodsilproj_r(i,face);
      }
      i=sil[i].next;
    } while(i!=siltab[j]);
  }

#endif
}
