#ifndef _sil_hpp_
#define _sil_hpp_
#include "struct.hpp"
#include "vect.hpp"
#include <stdio.h>
#include <stdlib.h>


#define SILELMVIS 1
#define SILELMBACK 4
#define SILELMPROJ 8

#define SILELMCROSS 2
#define SILELMSTART 16
#define SILELMSTOP 32
#define SILELMFIRST 64
#define SILELMENTER 128

//#define SILELMORIG

#define SILELMDEB 16384
#define SILELMMARK 32768

struct silelm_t {
  vec3_t pos;
  vec3_t proj; //seulement si visible

  int v; // he d'origine
  int flag; // visible, cross, back //->short
  int cross; // num silelm cross // seulement si cross //->short
  int so; // sil d'origine // ->short
  int face;

  int next,prev; //->short

};

extern int debsil;

class sil_t{
protected:

  int allocsilelm();
  void deallocsilelm(int i);
  bool testvis_r(int bsp,const vec3_t a,const vec3_t b);
  void printflag(int i);
  void printsil(int i);
  int projectbsp_r(vec3_t a,vec3_t b,vec3_t proj,bool vect,int bsp,int &last);
  int projectbsp(int i,vec3_t proj);
  int project(int i,int face,vec3_t proj,int oldface=-1) ;
  void floodsilproj_r(int i,int face);
  void floodsilproj(int i);
  void cutsilelm(int &j,int &j1,int &j2,vec_t pj[3],int &ss);
  bool testintersect_(int &i,int &si,char *tabi);


  void part_sil();
  void part_createstr();
  void part_intersect();
  void part_vis();
  void part_proj();

public:
  sil_t() {
    sil=NULL;
  }

  void computesil(scene_t *,float[3],int);

  bool testvis(vec3_t v);
  void camera(vec3_t cam) {
    cameravis=testvis(cam);
  }

  silelm_t *sil;
  //FIX
  int siltab[100];
  int nbrsil;

  bool cameravis;

protected:
  int nbrhesil2;
  char *tabi;


  scene_t *s;
  vec3_t pos;

  int nbrintersect;

  int silsize;
  int silfree;
  int nbrhesil;
  int mask;
};

#endif
