#include "struct.hpp"
#include "vect.hpp"
#include "sil.hpp"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//FIX ->utils ?
#define EPSILON 0.00001

/**********
(probleme: apres les cut pour l'intersect, il va recutter) -> tabi
utilisation de tabi: il faut fixer ca...
trouver autre algo pour intersect sans tabi et robuste
essayer de virer nestlist et prevlist

***********/


/************ strucure ***********/


#define NEXT(j) {if(j==s->fa[s->ve[j].face].vertex+s->fa[s->ve[j].face].nbrvertex-1) j=s->fa[s->ve[j].face].vertex; else j++;}
#define OP(j) {j=s->fa[s->ve[j].faceop&((1<<24)-1)].vertex+s->ve[j].indop;}

/********* test visibilitee ******/

// -> utils
static int checkvertex(scene_t *s,const vec3_t v,int plane)
{
  float d;
  if(plane<0)
    d=-vec3DotProduct(v,s->pl[-plane].n)-s->pl[-plane].n[3];
  else
    d=vec3DotProduct(v,s->pl[plane].n)+s->pl[plane].n[3];
  if(d>EPSILON) return 1;
  if(d<-EPSILON) return -1;
  return 0;
}

// -> utils
static void intersectplane(scene_t *s,int plane,const vec3_t a,const vec3_t b,vec3_t c)
{
  if(plane<0) plane=-plane;
  //c=a+t*(b-a);
  vec3Copy(b,c);
  vec3Sub_(a,c);
  float t=(-vec3DotProduct(s->pl[plane].n,a)-s->pl[plane].n[3])
    /vec3DotProduct(s->pl[plane].n,c);
  vec3Scale_(t,c);
  vec3Add_(a,c);
}

static void intersectplane(scene_t *s,float plane[4],const vec3_t a,const vec3_t b,vec3_t c)
{
  vec3Copy(b,c);
  vec3Sub_(a,c);
  float t=(-vec3DotProduct(plane,a)-plane[3])
    /vec3DotProduct(plane,c);
  //printf("%f\n",t);
  vec3Scale_(t,c);
  vec3Add_(a,c);
}

// FIX
static int debsil=0;

static bool testvis_r(scene_t *s,int bsp,const vec3_t a,const vec3_t b)
{
  if(bsp>0) {
    if((s->bl[bsp].flag)&LEAFBLOCK) 
      return false;
    return true;
  } else {
    bsp=-bsp;
    int da=checkvertex(s,a,s->bi[bsp].plane);
    int db=checkvertex(s,b,s->bi[bsp].plane);
    if(da==0 && db==0) return testvis_r(s,s->bi[bsp].child[0],a,b) 
			 || testvis_r(s,s->bi[bsp].child[1],a,b);
    if(da>=0 && db >=0) return testvis_r(s,s->bi[bsp].child[0],a,b);
    else if(da<=0 && db <=0) return testvis_r(s,s->bi[bsp].child[1],a,b);
    else {
      vec3_t c;
      intersectplane(s,s->bi[bsp].plane,a,b,c);
      if(da>0) return testvis_r(s,s->bi[bsp].child[0],a,c) &&
		 testvis_r(s,s->bi[bsp].child[1],c,b);
      else return testvis_r(s,s->bi[bsp].child[0],b,c) &&
	     testvis_r(s,s->bi[bsp].child[1],c,a);
    }
  }
}

static bool testvis(scene_t *s,vec3_t pos,vec3_t v)
{
  return testvis_r(s,-1,pos,v);
} 

/*************/

silelm_t *sil=NULL;
int silstart;

static int silsize;
static int silend;
static int silfree;

inline static int allocsilelm()
{
  if(silfree!=-1) {
    int i=silfree;
    silfree=sil[silfree].nextlist;
    return i;
  } else {
    printf("Erreur FIX\n");
    exit(1);
  }
}

inline static void deallocsilelm(int i)
{
  sil[i].nextlist=silfree;
  silfree=i;
}

//ajoute a la fin de la liste
inline static void addsilelm(int i)
{
  sil[silend].nextlist=i;
  sil[i].prevlist=silend;
  silend=i;
  sil[i].nextlist=-1;
}

/*******************************/

void printsil(int i)
{
  printf("sil[%d]: n=%d p=%d c=%d\n",i,sil[i].next,sil[i].prev,sil[i].cross);
}

static void cutsilelm(int &j,int &j1,int &j2,float pj[3])
{
  if(silstart==j) silstart=sil[j].nextlist;

  j1=allocsilelm();
  j2=allocsilelm();
  //printf("cut %d %d %d\n",j,j1,j2);
  
  // next prev
  sil[j1].next=j2;
  sil[j2].next=sil[j].next;
  sil[j2].prev=j1;
  sil[j1].prev=sil[j].prev;
  sil[sil[j].prev].next=j1;
  sil[sil[j].next].prev=j2;

  vec3Copy(sil[j].pos,sil[j1].pos);
  vec3Copy(pj,sil[j2].pos);
  //vec3Copy(sil[j].pos,sil[j2].pos);

  sil[j2].v=sil[j1].v=sil[j].v;
  
  sil[j1].flag=sil[j2].flag=sil[j].flag;
  sil[j2].flag|=SILELMCROSS;
  sil[j1].cross=sil[j].cross;
  if(sil[j].flag & SILELMCROSS) {
    sil[sil[j].cross].cross=j1;
  }
  
  addsilelm(j1);
  addsilelm(j2);
}

static void removesilelm(int i)
{
  if(sil[i].prevlist==-1)
    silstart=sil[i].nextlist;
  else
    sil[sil[i].prevlist].nextlist=sil[i].nextlist;

  if(sil[i].nextlist==-1)
    silend=sil[i].prevlist;
  else
    sil[sil[i].nextlist].prevlist=sil[i].prevlist;
}

static int nbrintersect;

static bool testintersect_(scene_t *s,int &i,float pos[3],char *tabi)
{
  int j;
  int vo=sil[i].v;
  float n[4];
  float u[3],v[3];
  float n2[4];

  // on utilise vertex pour que le plan soit valide
  // FIX gerer le cas ou les 3 points sont colineaires
  OP(vo);
  vec3Copy(s->ve[sil[i].v].pos,u);
  vec3Copy(s->ve[vo].pos,v);
  vec3Sub_(pos,u);
  vec3Sub_(pos,v);
  vec3CrossProduct(u,v,n);
  n[3]=-vec3DotProduct(n,pos);

  j=silstart;
  if(i==j) return false;
  do{
    //if(j==-1) Error("j==-1");

    int ok=0;
    if(1||tabi[sil[i].v*s->nve+sil[j].v]==0) ok=1;
    if(i==j || i==sil[j].next || i==sil[j].prev) ok=0;
    if((sil[i].flag & SILELMCROSS) && (sil[i].cross==j || sil[i].cross==sil[j].next)) ok=0;
    if((sil[j].flag & SILELMCROSS) && /*(sil[j].cross==i) ||*/ (sil[j].cross==sil[i].next)) ok=0;
    if((sil[sil[i].next].flag & SILELMCROSS) && (sil[sil[i].next].cross==sil[j].next)) ok=0;

    if(ok) {
    //tabi[sil[i].v*s->nve+sil[j].v]=tabi[sil[j].v*s->nve+sil[i].v]=1;
      int k=sil[j].next;
    float d=vec3DotProduct(n,sil[j].pos)+n[3];
    float d2=vec3DotProduct(n,sil[k].pos)+n[3];
    // FIX probleme si == 0. (au coup d'apres plan n'est pas valide)
    // le plan sera OK car utilisation de s->ve
    if(d==0.) d=1.;
    if(d2==0.) d2=1.;
    if((d<0.) ^ (d2<0.)) {
      // l'autre test
      int vo2=sil[j].v;
      OP(vo2);
      vec3Copy(s->ve[sil[j].v].pos,u);
      vec3Copy(s->ve[vo2].pos,v);
      vec3Sub_(pos,u);
      vec3Sub_(pos,v);
      vec3CrossProduct(u,v,n2);
      n2[3]=-vec3DotProduct(n2,pos);

      k=sil[i].next;
      d=vec3DotProduct(n2,sil[i].pos)+n2[3];
      d2=vec3DotProduct(n2,sil[k].pos)+n2[3];
      if(d==0.) d=1.;
      if(d2==0.) d2=1.;
      if((d<0.) ^ (d2<0.)) {
	
	int ii;
	int i1,i2,j1,j2;
	vec3_t pi,pj;

	// calcul des nouveaux points
	intersectplane(s,n2,s->ve[sil[i].v].pos,s->ve[vo].pos,pi);
	intersectplane(s,n,s->ve[sil[j].v].pos,s->ve[vo2].pos,pj);
	//printf("%f %f %f\n",pi[0],pi[1],pi[2]);	
	//printf(" %f %f %f\n",pj[0],pj[1],pj[2]);

	vec3Copy(pi,u);
	vec3Sub_(pos,u);
	vec3Copy(pj,v);
	vec3Sub_(pos,v);
	if(vec3DotProduct(u,v)>0.) {
	  
	  //FIX
	  if(tabi[sil[i].v*s->nve+sil[j].v]) {
	    printf("deja!!!: ");
	    printf("i.n=%d j.n=%d\n",sil[i].next,sil[j].next);
	  }
	  tabi[sil[i].v*s->nve+sil[j].v]=tabi[sil[j].v*s->nve+sil[i].v]=1;

	  nbrintersect++;
	//printf("lalala\n");
	  //printf("intersect %d: %d %d ",nbrintersect,i,j);
	  //printf("%d %d\n",sil[i].v,sil[j].v);
	
	//if(sil[i].inter || sil[j].inter) 
	  //printf("OLD %d %d\n",sil[i].inter,sil[j].inter);

	/*
	vec3_t w;
	vec3CrossProduct(u,v,w);
	float l=vec3Length(w)/vec3Length(u)/vec3Length(v);
	printf("l=%f\n",l);
	*/
	
	//printsil(i);printsil(j);
	cutsilelm(i,i1,i2,pi);
	cutsilelm(j,j1,j2,pj);
	//printsil(i1);printsil(i2);
	//printsil(j1);printsil(j2);

	
	sil[j2].cross=i2;
	sil[i2].cross=j2;
	
	ii=sil[i].nextlist;
	removesilelm(i);
	removesilelm(j);
	deallocsilelm(i);
	deallocsilelm(j);
	i=ii;

	sil[j1].inter=sil[j2].inter=sil[i1].inter=sil[i2].inter=nbrintersect;

	return true;
	}
      }
    }
    }
    j=sil[j].nextlist;
  } while(j!=i);

  return false;
}

/****** MAIN ******/

void computesil(scene_t *s,float pos[3],int lum)
{
  int mask=(FLAGSIL<<lum);
  int i,j;
  int nbrhesil=0,nbrhesil2;
  char *tabi;
  
  nbrintersect=0;

  printf("SIL\n");

  /******** 1: trouve les he dans la silhouete ********/

  for(i=1;i<s->npl;i++) {
    if(vec3DotProduct(s->pl[i].n,pos)+s->pl[i].n[3] >0.)
      s->pl[i].flag|=mask;
    else 
      s->pl[i].flag&=~mask;
  }
  
  //pour toutes les faces
  for(i=0;i<s->nfa;i++) {
    int pl=s->fa[i].plane;
    if((pl>0 && (s->pl[pl].flag&mask)) ||
       (pl<0 && !(s->pl[-pl].flag&mask))) {
      s->fa[i].flag|=mask;
    }
    else 
      s->fa[i].flag&=~mask;
  }

  //pour toutes les faces
  for(i=0;i<s->nfa;i++) {
    if(s->fa[i].flag & mask)
      for(j=0;j<s->fa[i].nbrvertex;j++) {
	int n=s->ve[s->fa[i].vertex+j].faceop;
	//FIX
	n&=(1<<24)-1;
	if(!(s->fa[n].flag&mask)) {
	  s->ve[s->fa[i].vertex+j].flag|=mask;
	  s->ve[s->fa[i].vertex+j].flag&=~VERTEXMARK;
	  nbrhesil++;
	} else
	  s->ve[s->fa[i].vertex+j].flag&=~mask;
      }
    else
      for(j=0;j<s->fa[i].nbrvertex;j++)
	s->ve[s->fa[i].vertex+j].flag&=~mask;
  }

  /******** 2: creation de la structure ********/

  if(sil) free(sil);
  silsize=nbrhesil+1000;
  sil=(silelm_t*)malloc(sizeof(silelm_t)*silsize);
  nbrhesil2=nbrhesil;
  nbrhesil=0;
  
  for(i=0;i<s->nve;i++) 
    if(s->ve[i].flag&mask && !(s->ve[i].flag&VERTEXMARK)) {
      int j=i;
      int ns=nbrhesil;
      do{
	sil[nbrhesil].v=j;
	sil[nbrhesil].next=nbrhesil+1;
	sil[nbrhesil].prev=nbrhesil-1;
	s->ve[j].flag|=VERTEXMARK;
	nbrhesil++;
	NEXT(j);
	while(!(s->ve[j].flag&mask)){
	  OP(j);NEXT(j);
	}
      }while(!(s->ve[j].flag&VERTEXMARK));
      sil[nbrhesil-1].next=ns;
      sil[ns].prev=nbrhesil-1;
    }

  if(nbrhesil!=nbrhesil2) printf("Erreur %d != %d\n",nbrhesil2,nbrhesil);

#undef OP
#undef NEXT

  for(i=0;i<nbrhesil;i++) {
    sil[i].flag=0;
    vec3Copy(s->ve[sil[i].v].pos,sil[i].pos);
    sil[i].nextlist=i+1;
    sil[i].prevlist=i-1;
    sil[i].inter=0;
  }  

  sil[nbrhesil-1].nextlist=-1;
  sil[0].prevlist=-1;
  if(nbrhesil==silsize) silfree=-1;
  else {
    silfree=nbrhesil;
    for(i=nbrhesil;i<silsize;i++)
      sil[i].nextlist=i+1;
    sil[silsize-1].nextlist=-1;
  }
  silend=nbrhesil-1;

  /******** 3: intersections ********/

  tabi=(char*)malloc(s->nve*s->nve);
  bzero(tabi,s->nve*s->nve);

#if 1
  //for(i=0;i<nbrhesil;i++)
  //  testintersect(s,sil,nbrhesil,i,pos,tabi);
  
  i=silstart;
  do {
    if(!testintersect_(s,i,pos,tabi)){
      i=sil[i].nextlist;
    }
    else {
#if 0
      int k;
      for(k=silstart;k!=-1;k=sil[k].nextlist) {
	printf("%d",k);
	if(sil[k].flag&SILELMCROSS) printf("(%d)",sil[k].cross);
	printf(" ");
      }
      printf("\n");
#endif
    }
  } while(i!=-1);

#endif
  printf("%d he / %d hesil / %d intersect\n",s->nve,nbrhesil,nbrintersect);

  /******** 4: elms visibles ********/

#if 1
  //FIX faire des floods
  for(i=silstart;i!=-1;i=sil[i].nextlist) {
    vec3_t v;
    vec3Copy(sil[i].pos,v);
    vec3Add_(sil[sil[i].next].pos,v);
    vec3Scale_(0.5,v);
    if(testvis(s,pos,v)) {
      sil[i].flag|=SILELMVIS;
      //s->ve[sil[i].v].flag|=FLAGSILM;
    }
    //else s->ve[sil[i].v].flag&=~FLAGSILM;
  }
#endif

  /******** 5: projections ********/

  // ?
  free(tabi);
  //free(sil);

  printf("\\SIL\n");
  fflush(stdout);
}



