#include "utils.hpp"
#include "vect.hpp"

int checkvertex(scene_t *s,const vec3_t v,int plane)
{
  float d;
  if(plane<0)
    d=-vec3DotProduct(v,s->pl[-plane].n)-s->pl[-plane].n[3];
  else
    d=vec3DotProduct(v,s->pl[plane].n)+s->pl[plane].n[3];
  if(d>EPSILON) return 1;
  if(d<-EPSILON) return -1;
  return 0;
}

int checkvertex(scene_t *s,const vec3_t v,vec4_t plane)
{
  float d;
  d=vec3DotProduct(v,plane)+plane[3];
  if(d>EPSILON) return 1;
  if(d<-EPSILON) return -1;
  return 0;
}

void intersectplane(scene_t *s,int plane,const vec3_t a,const vec3_t b,vec3_t c)
{
  if(plane<0) plane=-plane;
  //c=a+t*(b-a);
  vec3Copy(b,c);
  vec3Sub_(a,c);
  float t=(-vec3DotProduct(s->pl[plane].n,a)-s->pl[plane].n[3])
    /vec3DotProduct(s->pl[plane].n,c);
  vec3Scale_(t,c);
  vec3Add_(a,c);
}

void intersectplane(scene_t *s,float plane[4],const vec3_t a,const vec3_t b,vec3_t c)
{
  vec3Copy(b,c);
  vec3Sub_(a,c);
  float t=(-vec3DotProduct(plane,a)-plane[3])
    /vec3DotProduct(plane,c);
  //printf("%f\n",t);
  vec3Scale_(t,c);
  vec3Add_(a,c);
}
