#include "wp.hpp"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

wp_t wpl;

wp_t::~wp_t()
{
  delete[] pos;
}
  
void wp_t::load(const char* f)
{
  //FIX
  pos=new vec3_t[100];
  nbr=0;

  FILE *in=fopen(f,"rt");
  if(in==NULL) return;

  char buff[1001];

  fgets(buff,1000,in);
  while(!feof(in)) {
    char *p=strtok(buff," \n\t");
    if(p==NULL) break;
    pos[nbr][0]=atof(p);
    p=strtok(NULL," \n\t");
    pos[nbr][1]=atof(p);
    p=strtok(NULL," \n\t");
    pos[nbr][2]=atof(p);

    vec3Print(pos[nbr]);printf("\n");
    nbr++;
    fgets(buff,1000,in);
  }

  printf("%d points loaded\n",nbr);
  fclose(in);
  cur=0;
  dc=0.;
}

static vec_t forward_(vec3_t a,vec3_t b,vec3_t v,vec_t d)
{
  vec3Copy(b,v);
  vec3Sub_(a,v);
  vec_t l=vec3Len(v);
  vec3Scale_(d/l,v);
  vec3Add_(a,v);
  return d-l;
}

void wp_t::forward(vec_t d,vec3_t p)
{
  if(nbr==0) return;
  dc+=d;
  while((d=forward_(pos[cur],pos[(cur+1)%nbr],p,dc))>=0.) {
    dc=d;
    cur+=2;
    if(cur>=nbr) cur-=nbr;
    //printf("cur= %d %f\n",cur,d);
  }
}




