
// enregistre la version finale du bsp
#include "bspf.hpp"
#include "portal.hpp"

static void saveheader(ofstream &ou)
{
  ou.write(IDBSPF,4);
  int ver=VERSIONBSPF;
  ou.write((char*)&ver,4);
  //FIX
  unsigned int nbrbit=24;
  ou.write((char*)&nbrbit,2);
}

static void savelump(ofstream &ou,elumps_t lump, short ver, int size,int nbr)
{
  lump_t l;
  l.lump=lump;
  l.nbr=nbr;
  l.size=size;
  l.ver=ver;
  l.idlump='S'+256*'L';
  //ou.write(IDLUMP,2);
  //ou.write((char*)&lump,sizeof(lump));
  //ou.write((char*)&ver,2);
  //ou.write((char*)&size,4);
  //ou.write((char*)&nbr,4);
  ou.write((char*)&l,sizeof(lump_t));
}

static void closebspf(ofstream &ou)
{
  savelump(ou,end,0,0,0);
}

static void savevertex(ofstream &ou,vector<bspf_vertex_t> &tab)
{
  int nbr=tab.size();

  savelump(ou,vertex,1,sizeof(bspf_vertex_t),nbr);
  for(int i=0;i<nbr;i++)
    ou.write((char*)&tab[i],sizeof(bspf_vertex_t));
}

static void saveface(ofstream &ou,vector<bspf_face_t> &tab)
{
  int nbr=tab.size();

  savelump(ou,face,1,sizeof(bspf_face_t),nbr);
  for(int i=0;i<nbr;i++)
    ou.write((char*)&tab[i],sizeof(bspf_face_t));
}

static void saveplane(ofstream &ou,vector<bspf_plane_t> &tab)
{
  int nbr=tab.size();

  savelump(ou,plane,1,sizeof(bspf_plane_t),nbr);
  for(int i=0;i<nbr;i++)
    ou.write((char*)&tab[i],sizeof(bspf_plane_t));
}

static void savebsp_leaf(ofstream &ou,vector<bspf_leaf_t> &tab)
{
  int nbr=tab.size();

  savelump(ou,bsp_leaf,1,sizeof(bspf_leaf_t),nbr);
  for(int i=0;i<nbr;i++)
    ou.write((char*)&tab[i],sizeof(bspf_leaf_t));
}

static void savebsp_int(ofstream &ou,vector<bspf_int_t> &tab)
{
  int nbr=tab.size();

  savelump(ou,bsp_int,1,sizeof(bspf_int_t),nbr);
  for(int i=0;i<nbr;i++)
    ou.write((char*)&tab[i],sizeof(bspf_int_t));
}

static int cons_r(bsp_t *b,vector<bspf_leaf_t> &vl,vector<bspf_int_t> &vi,
		   vector<bspf_vertex_t> &vv,vector<bspf_face_t> &vf,
		   vector<bspf_plane_t> &vp)
{
  if(b->leaf) {
    //add bsp leaf
    int num=MASKNUM&b->num;
    bspf_leaf_t bf; 
    
    //printf("bsp leaf\n");
      
    bf.face=vf.size();
    bf.nbrface=0;
    bf.flag=0;
    if(b->id!=1) bf.flag|=LEAFBLOCK;
    
    // pour tous les portals normaux
    for(unsigned int i=0;i<b->portals.size();i++) 
      if(b->portals[i]->bsp[1]!=NULL) {
	portal_t *p=b->portals[i];
	// add plane
	
	int numplane;
	bspf_plane_t pl;
	vec4Copy(p->face.p.n,pl.n);
	
	for(numplane=1;numplane<(int)vp.size();numplane++) {
	  int l;
	  for(l=0;l<4;l++)
	    if(vp[numplane].n[l]!=pl.n[l]) break;
	  if(l==4) break;
	}
	
	if(numplane==(int)vp.size()) {
	  vec4Scale_(-1.,pl.n);
	  for(numplane=1;numplane<(int)vp.size();numplane++) {
	    int l;
	    for(l=0;l<4;l++)
	      if(vp[numplane].n[l]!=pl.n[l]) break;
	    if(l==4) break;
	  }
	  
	  if(numplane==(int)vp.size()) {
	    Warn("add plane");
	    /*
	    for(numplane=1;numplane<(int)vp.size();numplane++){
	      for(int m=0;m<4;m++)
		printf("%f ",(double)vp[numplane].n[m]);
	      //printf("%f \n",(double)vp[numplane].n[3]/vp[numplane].n[1]);
	      printf("\n");
	    }
	    */
	    for(int m=0;m<4;m++)
	      printf("%f ",(double)pl.n[m]);
	    //printf("%f \n",(double)pl.n[3]/pl.n[1]);
	    printf("\n");
	    vp.push_back(pl);
	  } else {
	    numplane=-numplane;
	  }
	}
	
	//printf("portal\n");

	if(b==p->bsp[1]) numplane=-numplane;
	
	for(unsigned int j=0;j<p->listfaces.size();j++) 
	  //FIX
	  if(p->listfaces[j]->flags & FACE_DRAW) {
	    vec_t d=vec3DotProduct(p->listfaces[j]->p.n,p->face.p.n);
	    if(((d>0.) && b==p->bsp[0]) || ((d<0.) && b==p->bsp[1])) {
	      // add face et add vertices
	      bf.nbrface++;
	      face_t *f=p->listfaces[j];
	      bspf_face_t ff;
	      //printf("add face %d\n",f->num&MASKNUM);
	      if((f->num&MASKNUM)!=(int)vf.size()) 
		Error("num face %d should be %d",f->num&MASKNUM,vf.size());
	      ff.plane=numplane;
	      ff.vertex=vv.size();
	      ff.nbrvertex=0;
	      plane_t p0,p1;
	      p0.n[3]=p1.n[3]=0.;
	      //FIX utiliser info text_t
	      int lele=0;vec_t mlele=fabs(f->p.n[0]);
	      for(int lala=1;lala<3;lala++) {
		if(mlele>fabs(f->p.n[lala])) 
		  {lele=lala;mlele=fabs(f->p.n[lala]);}
	      }
	      vec3_t lili={0.,0.,0.};
	      lili[lele]=1.;
	      vec3CrossProduct(f->p.n,lili,p0.n);
	      p0.norm();
	      vec3CrossProduct(f->p.n,p0.n,p1.n);
	      p1.norm();
	      //printf("%f %f %f %f\n",p0.n[0],p0.n[1],p0.n[2],p0.n[3]);
	      vec4Scale_(1./64.,p0.n);
	      vec4Scale_(1./64.,p1.n);
	      //texture, type...
	      for(unsigned int k=0;k<f->tab.size();k++) {
		ff.nbrvertex++;
		bspf_vertex_t ver;
		vec3Copy(f->tab[k].v,ver.pos);
		//normal
		ver.texpos[0]=vec3DotProduct(p0.n,f->tab[k].v)+p0.n[3];
		ver.texpos[1]=vec3DotProduct(p1.n,f->tab[k].v)+p1.n[3];
		ver.faceop=f->tab[k].op;
		ver.indop=f->tab[k].indop;
		vv.push_back(ver);
	      }
	      vf.push_back(ff);
	    }
	  }
      }
    vl[num]=bf;
    
    return num;
  } else {
    //add bsp int
    bspf_int_t *bf;
    int num=(MASKNUM&b->num)| ~MASKNUM;
    num=-num;
    bf=&vi[num];

    //add plane
    int numplane;
    bspf_plane_t pl;
    vec4Copy(b->plane.n,pl.n);
   
    for(numplane=1;numplane<(int)vp.size();numplane++) {
      int l;
      for(l=0;l<4;l++)
	if(vp[numplane].n[l]!=pl.n[l]) break;
      if(l==4) break;
    }

    if(numplane==(int)vp.size()) {
      vec4Scale_(-1.,pl.n);
      for(numplane=1;numplane<(int)vp.size();numplane++) {
	int l;
	for(l=0;l<4;l++)
	  if(vp[numplane].n[l]!=pl.n[l]) break;
	if(l==4) break;
      }
      
      if(numplane==(int)vp.size()) {
	vec4Scale_(-1.,pl.n);
	vp.push_back(pl);
      } else {
	numplane=-numplane;
      }
    }
    
    bf->plane=numplane;
    
    /*
      //ancienne methode on ajoutait tout le temps, 
      // pas bon car face d'un leaf peut avoir plane qui etait pas dans 
      // le chemin depuis la racine
    bspf_plane_t p;
    bf->plane=vp.size();
    vec4Copy(b->plane.n,p.n);
    vp.push_back(p);
    */
    
    //rec
    //FIX inutile de renvoyer num
    bf->child[0]=cons_r(b->child[0],vl,vi,vv,vf,vp);
    bf->child[1]=cons_r(b->child[1],vl,vi,vv,vf,vp);
    //bf->child[0]=;
    //bf->child[1]=;
    return -num;
  }
}

void saveFinalBsp(hstr_t *h,char *filename)
{
  vector<bspf_leaf_t> vl(h->nbrleaf+1);
  vector<bspf_int_t> vi(h->nbrnodeint+1);
  vector<bspf_vertex_t> vv;
  vector<bspf_face_t> vf;
  vector<bspf_plane_t> vp(1); //[0] ne sert pas

  //printf("portal de l'exterieur %d\n",h->ext->portals.size());

  if(h->bsp->leaf==1 || (h->bsp->num & MASKNUM)!=MASKNUM)
    Error("numerotation root bsp %X %d",h->bsp->num,((h->bsp->num&MASKNUM)| ~MASKNUM));

  ofstream ou(filename,fstream::binary|fstream::out);
  
  saveheader(ou);

  // parcour du bsp -> cree les bspf_leaf,  bspf_int et plane
  // vertex, faces
  cons_r(h->bsp,vl,vi,vv,vf,vp);

  savevertex(ou,vv);
  saveface(ou,vf);
  saveplane(ou,vp);
  savebsp_leaf(ou,vl);
  savebsp_int(ou,vi);

  // (vis)
  // (textures)

  // ((illum))

  closebspf(ou);
  ou.close();
}
