#include <iostream>
using namespace std;

#include "face.hpp"
#include "map.hpp"
#include "bsp.hpp"
#include "buildbspfaces.hpp"
#include "portal.hpp"
#include "zone.hpp"
#include "tjunc.hpp"
#include "simplface.hpp"
#include "he.hpp"
#include "pvs.hpp"
#include "bspf.hpp"

bool adjzone[MAXZONES][MAXZONES];

void correct_face_r(bsp_t *b)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) {
      if(b==b->portals[i]->bsp[0]) {
	for(unsigned int j=0;j<b->portals[i]->listfaces.size();j++) {
	  if(vec3DotProduct(b->portals[i]->face.p.n,b->portals[i]->listfaces[j]->p.n)<0) {
	    b->portals[i]->listfaces[j]->reverse();
	    //printf("reverse\n");
	  }
	}
      }
    }
  } else {
    correct_face_r(b->child[0]);
    correct_face_r(b->child[1]);
  }
}

void recorrect_face_r(bsp_t *b)
{
  if(b->leaf) {
    if(b->id==1) {
      for(unsigned int i=0;i<b->portals.size();i++) {
	if(b->portals[i]->bsp[b==b->portals[i]->bsp[0]]->id!=1) {
	  if(b==b->portals[i]->bsp[1]) {
	    for(unsigned int j=0;j<b->portals[i]->listfaces.size();j++) {
	      //if(vec3DotProduct(b->portals[i]->face.p.n,b->portals[i]->listfaces[j]->p.n)<0) {
	      b->portals[i]->listfaces[j]->reverse();
	      //printf("re reverse\n");
	      //}
	    }
	  }
	}
      }
    }
  } else {
    recorrect_face_r(b->child[0]);
    recorrect_face_r(b->child[1]);
  }
}


void adjzone_r(bsp_t *b)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) {
      int x=b->portals[i]->bsp[0]->id;
      int y=b->portals[i]->bsp[1]->id;
      if(x<0) x=0;
      if(y<0) y=0;
      adjzone[x][y]=true;
      adjzone[y][x]=true;
    }
  } else {
    adjzone_r(b->child[0]);
    adjzone_r(b->child[1]);
  }
}


void addportals(vector<face_t*> &v,bsp_t *b,int z)
{
  if(b->leaf) {
    if(b->id==z) {
      for(unsigned int i=0;i<b->portals.size();i++) {
	bsp_t *b2=b->portals[i]->bsp[0];
	if(b==b2) 
	  b2=b->portals[i]->bsp[1];
	if(b2->id!=z) {
	  face_t *f=new face_t(b->portals[i]->face);
	  //FIX FIX FIX !!!
	  // prendre face des portals et pas portals !!!
	  if(b->portals[i]->flag & PRT_ZONE) f->flags=FACE_ZONE;
	  if(b->portals[i]->flag & PRT_BLOCK) f->flags=FACE_BLOCK|FACE_DRAW;
	  
	  // pour portals limites
	  f->i0=b2->num;

	  // FIX
	  //if(b==b->portals[i]->bsp[1]) f->reverse();
	  v.push_back(f);
	  //printf("%d %d\n",z,b2->id);
	}
      }
    }
  } else {
    addportals(v,b->child[0],z);
    addportals(v,b->child[1],z);
  }
}

void addportalfaces(vector<face_t*> &v,bsp_t *b,int z)
{
  if(b->leaf) {
    if(b->id==z) {
      for(unsigned int i=0;i<b->portals.size();i++) {
	bsp_t *b2=b->portals[i]->bsp[0];
	if(b==b2) 
	  b2=b->portals[i]->bsp[1];
	if(b2->id!=z) {
	  for(unsigned int j=0;j<b->portals[i]->listfaces.size();j++) {
	    face_t *f=new face_t(*(b->portals[i]->listfaces[j]));
	    
	    // FIX
	    //if(b==b->portals[i]->bsp[1]) f->reverse();
	    v.push_back(f);
	    //if(f->tab.size()!=4) Error(" ");
	  }
	}
      }
    }
  } else {
    addportalfaces(v,b->child[0],z);
    addportalfaces(v,b->child[1],z);
  }
}

int numBspLeaf(bsp_t *b,int &n,bool in)
{
  if(b->leaf==0) {
    return numBspLeaf(b->child[0],n,in)+numBspLeaf(b->child[1],n,in);
  } else {
    if((in && b->id==1) || (b->id!=1 && !in)) {
      b->num=n++;
      return 1;
    }
    return 0;
  }
}

int numBspInt(bsp_t *b,int &n)
{
  if(b->leaf==0) {
    b->num=n--;
    return 1+numBspInt(b->child[0],n)+numBspInt(b->child[1],n);
  } else return 0;
}

#ifdef DEBUG
// FIX a jetter a la poubelle
struct foo_t{int f;int n;};
static void faceflag(vector<face_t*> v)
{
  vector<foo_t> vv;
  unsigned int i;
  for(i=0;i<v.size();i++) {
    unsigned int j;
    for(j=0;j<vv.size();j++) 
      if(v[i]->flags==vv[j].f) break;
    if(j==vv.size()) {vv.resize(vv.size()+1);vv[j].f=v[i]->flags;vv[j].n=0;}
    vv[j].n++;
  }
  for(i=0;i<vv.size();i++)
    printf("%d: %d ",vv[i].f,vv[i].n);
  printf("\n");
}
#endif

int main()
{
  map_t *zones;
  map_t *m;
  unsigned int i,j;
  hstr_t *h;
  char filen[100];

  //debug:
  vector<face_t*> fvis2;

  char filescript[]="test2.mscr";

  printf("MAXZONES=%d\n",MAXZONES);

  printf("***** ZONES *****\n");
  zones=readMap(NULL,filescript,READMAP_ZONE);
  hstr_t *bz=buildbspfaces(zones->tabfa);
  // parcours
  printbspstat(bz->bsp);
  // infos portals
  bspMaskPrt(bz->bsp); // flag =  0  pour tous les portals
  bspPrt(bz->bsp); 
  // floods
  unsigned int nbrzone=floodZone(bz);
  // adjacence des zones
  if(nbrzone>=MAXZONES) Error("MAXZONES");
  for(i=0;i<=nbrzone;i++)
    for(j=0;j<=nbrzone;j++) adjzone[i][j]=false;
  // adjzone
  adjzone_r(bz->bsp);
  printf("Adjacences:\n");
  for(i=0;i<=nbrzone;i++) {
    for(j=0;j<=nbrzone;j++) cout << adjzone[i][j];
    cout <<endl;
  }
  
  unsigned int zone;
  
  printf("\n******************\n");
  printf("***** PASS 1 *****\n");
  printf("******************\n");

  // pour chaque zone 
  for(zone=1;zone<=nbrzone;zone++) {
    printf("***** Zone %d *****\n",zone);
    readMapBspZ(bz->bsp,zone);
    //  lire la map dans la zone
    m=readMap(NULL,filescript);

    /****** BSP PASS 1 ******/
    /* CSG, elimination de surfaces cachees */
    
    //  ajouter face de la zone
    addportals(m->tabfa,bz->bsp,zone);

    //  calcul BSP + portals (passe 1)
    h=buildbspfaces(m->tabfa);
    printbspstat(h->bsp);

    // infos portals
    bspMaskPrt(h->bsp);
    bspPrt(h->bsp); 

    //correct 
    //FIX inutile ?
    correct_face_r(h->bsp);

    //  flood 
    //  id==-1: pas dans la zone
    //  id==1 : interieur
    bspId(h->bsp,-1);
    h->ext->id=-1;
    //flood(h->ext,-1,PRT_ZONE); // flood exterieur

    // flood pour flags
    for(i=0;i<m->tabent.size();i++) {
      if(!strcmp(m->tabent[i]->name,"struc_in")) {
	//printf("id %d\n",searchbsp(h->bsp,m->tabent[i]->pos)->id);
	flood(searchbsp(h->bsp,m->tabent[i]->pos),0,PRT_ZONE);
      }
    }
    
    // flood depuis struct_in
    for(i=0;i<m->tabent.size();i++) {
      if(!strcmp(m->tabent[i]->name,"struc_in")) {
	//printf("id %d\n",searchbsp(h->bsp,m->tabent[i]->pos)->id);
	flood(searchbsp(h->bsp,m->tabent[i]->pos),1,PRT_ZONE | PRT_BLOCK);
      }
    }

    // verif struct_out
    for(i=0;i<m->tabent.size();i++) {
      if(!strcmp(m->tabent[i]->name,"struc_out")) {
	if(searchbsp(h->bsp,m->tabent[i]->pos)->id==1) {
	  Warn("struc_out inside");
	  cout << "position: " << m->tabent[i]->pos[0] << " " << m->tabent[i]->pos[1] << " " << m->tabent[i]->pos[2] << endl;
	}
      }
    }
    
    //  garde faces visibles
    vector<face_t*> fvis;
    //FIX?
    addportalfaces(fvis,h->bsp,1);
    printf("%d faces visibles\n",fvis.size());

    //TEST
    sprintf(filen,"fvis%d.truc",zone);
    writeTruc(fvis,filen,0);
    
    //  detruit bsp
    destroyBsp(h);

    /****** BSP PASS 2 ******/
    /* Calcul du bsp final */
    
#ifdef DEBUG
    // FIX REMOVE
    for(unsigned lalala=0;lalala<fvis.size();lalala++)
      fvis[lalala]->test();
#endif

    //  ajouter face de la zone
    addportals(fvis,bz->bsp,zone);

    //  calcul BSP + portals (passe 2)
    h=buildbspfaces(fvis);
    destroyVectorFace(fvis); 
    printbspstat(h->bsp);

    // infos portals
    bspMaskPrt(h->bsp);
    bspPrt(h->bsp); 

    //  flood 
    //  id==-1: pas dans la zone
    //  id==1 : interieur
    bspId(h->bsp,-1);
    h->ext->id=-1;
    //flood(h->ext,-1,PRT_ZONE); // flood exterieur

    //flood pour flags
    for(i=0;i<m->tabent.size();i++) {
      if(!strcmp(m->tabent[i]->name,"struc_in")) {
	//printf("id %d\n",searchbsp(h->bsp,m->tabent[i]->pos)->id);
	flood(searchbsp(h->bsp,m->tabent[i]->pos),0,PRT_ZONE);
      }
    }

    //flood depuis struct_in
    for(i=0;i<m->tabent.size();i++) {
      if(!strcmp(m->tabent[i]->name,"struc_in")) {
	//printf("id %d\n",searchbsp(h->bsp,m->tabent[i]->pos)->id);
	flood(searchbsp(h->bsp,m->tabent[i]->pos),1,PRT_ZONE | PRT_BLOCK);
      }
    }

    // numerote des brushs
    int numb=(zone<<BITFORNUMBSP)+1;
    h->ext->num=numb+0;
    h->nbrleafin=numBspLeaf(h->bsp,numb,true);
    h->nbrleaf=h->nbrleafin+numBspLeaf(h->bsp,numb,false);
    numb=(zone<<BITFORNUMBSP)+NUMEXTBSP;
    h->nbrnodeint=numBspInt(h->bsp,numb);
    printf("%d nodes int, %d leaves, %d leaves in\n",
	   h->nbrnodeint,h->nbrleaf,h->nbrleafin);
    
    //correct
    //FIX innutile ?
    correct_face_r(h->bsp);
    recorrect_face_r(h->bsp);

#ifdef DEBUG
    //TEST
    addportalfaces(fvis2,h->bsp,1);
    faceflag(fvis2);
    sprintf(filen,"vface_%d.truc",zone);
    writeTruc(fvis2,filen,0);
    destroyVectorFace(fvis2); 
#endif

    // simplify
    simplify(h);

    //correct
    correct_face_r(h->bsp);
    recorrect_face_r(h->bsp);

#ifdef DEBUG
    //TEST
    addportalfaces(fvis2,h->bsp,1);
    faceflag(fvis2);
    sprintf(filen,"vface_simpl_%d.truc",zone);
    writeTruc(fvis2,filen,0);
    destroyVectorFace(fvis2); 
#endif

    //tjunc
    printf("--- FIX T-JUNCTIONS ---\n");
    //calcul de liste vertex
    vector<vertex_t> vv;
    listvertex_r(vv,h->bsp);
    //printf("%d sommets\n",vv.size());
    // fix tjunc
    fixTjunc_r(vv,h->bsp);

    //calcul et enregistrement liste vertex limites
    vv.resize(0);
    listvertex_r(vv,h->bsp,true);
    printf("%d limit vertices\n",vv.size());
    sprintf(filen,"vlim%d.bin",zone);
    saveVectorVertex(vv,filen);

    // Enregistrement

    // liste portals limites
    vector<face_t*> plim;
    addportals(plim,h->bsp,-1);
    addportals(plim,h->ext,-1); // ?
    printf("%d portals limites\n",plim.size());
    sprintf(filen,"plim%d.bin",zone);
    saveVectorFace(plim,filen);
    destroyVectorFace(plim); 

    // enregistrement bsp
    sprintf(filen,"bsp%d.bin",zone);
    saveBsp(h,filen);

    // destruction
    destroyBsp(h);
    //destroyMap(m);
    // FIX rien d'autre ?
  }

  printf("\n******************\n");
  printf("***** PASS 2 *****\n");
  printf("******************\n");

  // pour chaque zone 
  for(zone=1;zone<=nbrzone;zone++) {
    unsigned int z2;

    printf("***** Zone %d *****\n",zone);
    // lit le bsp
    hstr_t *h;
    sprintf(filen,"bsp%d.bin",zone);
    h=loadBsp(filen);
    //recree infos manquantes
    reconsBsp(h); //recree les brush du bsp

    printf("--- PORTALS INTERZONES ---\n");
    for(z2=1;z2<=nbrzone;z2++) 
      if(z2!=zone && adjzone[zone][z2]) {
	//printf("****** ZONES %d - %d ******\n",zone,z2);
	
	//  lecture des portals limites
	vector<face_t*> plim;
	sprintf(filen,"plim%d.bin",z2);
	loadVectorFace(plim,filen);
	printf("%d faces limites, ",plim.size());
	
	//  correspondance portals
	corzone(plim,h);

	// destruction
	destroyVectorFace(plim); 
      }

    
    printf("--- FIX T-JUNCTIONS ---\n");
    // lecture des vertex limites de toutes les zones adjacentes
    vector<vertex_t> vv;
    for(z2=1;z2<=nbrzone;z2++) 
      if(z2!=zone && adjzone[zone][z2]) {
	sprintf(filen,"vlim%d.bin",z2);
	loadVectorVertexAppend(vv,filen);
      }

    // fix tjunc
    fixTjunc_r(vv,h->bsp);

    //numerote faces
    int numptr=0;
    numface_r(h->bsp,numptr,zone);

    // liste hedge
    vector<hedge2_t> he;
    vector<hedge2_t> helim;
    listhedge2_r(h->bsp,he,false);
    helimzone(h->bsp,he,helim);

    // Enregistrement
    // ecrase l'ancien bsp
    sprintf(filen,"bsp%d.bin",zone);
    saveBsp(h,filen);
    //hedges 
    sprintf(filen,"helim%d.bin",zone);
    saveVectorHE(helim,filen);

    //destruction
    destroyBsp(h);
    // FIX rien d'autre ?
  }

  printf("\n******************\n");
  printf("***** PASS 3 *****\n");
  printf("******************\n");

  //correspondance hedge
  for(zone=1;zone<=nbrzone;zone++) {
    unsigned int z2;

    printf("***** Zone %d *****\n",zone);
    // lit le bsp
    hstr_t *h;
    sprintf(filen,"bsp%d.bin",zone);
    h=loadBsp(filen);
    //recree infos manquantes
    reconsBsp(h); //recree les brush du bsp

    printf("--- HE ---\n");
    // lecture des HE limites de toutes les zones adjacentes
    vector<hedge2_t> vv;
    for(z2=1;z2<=nbrzone;z2++) 
      if(z2!=zone && adjzone[zone][z2]) {
	sprintf(filen,"helim%d.bin",z2);
	loadVectorHEAppend(vv,filen);
      }
    
    // garde seulement les HE dans la zone
    vector<hedge2_t> vv2;
    heinzone(h->bsp,vv,vv2);

    //he
    halfedge(h,vv2,zone);

    // Enregistrement Final
    sprintf(filen,"zone_%03d.map",zone);
    //saveBsp(h,filen);
    saveFinalBsp(h,filen);

    //destruction
    destroyBsp(h);
    // FIX rien d'autre ?
  }

#if 0
  printf("\n***************\n");
  printf("***** PVS *****\n");
  printf("***************\n");

  for(zone=1;zone<=nbrzone;zone++) {
    printf("***** Zone %d *****\n",zone);
    // lit le bsp
    hstr_t *h;
    sprintf(filen,"bsp%d.bin",zone);
    h=loadBsp(filen);
    //recree infos manquantes
    reconsBsp(h); //recree les brush du bsp
    
    //vector<bool> vis;
    //recup nombre de noeud (feuilles ?)
    
    if(zone==2) 
      visflood(h);

    //destruction
    destroyBsp(h);
  }
#endif

  // pour chaque brush de chaque zone
  //  flood avec chargement des zones necessaires
  // -> pvs entre les zones 

  // illum ?
  
  return 0;
}

