/* create a bsp & portals, from a list of faces */

#include "buildbspfaces.hpp"
#include "bsp.hpp"
#include "utils.hpp"
#include "portal.hpp"
#include "brush.hpp"

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

/* cut a listface by a plane
   destroy a*/
static void cutlistface(vector<face_t*> &a,vector<face_t*> &b,vector<face_t*> &c,vector<face_t*> &d,plane_t *p)
{
  plane_t mp=p->opp();
  
  while(a.size()>0) {
    face_t *f=a[a.size()-1];
    a.pop_back();

    //if(f->p==*p || f->p==mp) {
    if(f->checkIntersectFace(p)==-1) {
      d.push_back(f);
    } else {
      face_t *fa=new face_t(*f);
      fa->cutByPlane(p);
      f->cutByPlane(&mp);
      
      if(fa->tab.size()>0) {
	b.push_back(fa);
      } else {
	delete fa;
      }
      if(f->tab.size()>0) {
	c.push_back(f);
      } else {
	delete f;
      }
    }
  }
}

/* find a plane to cut the listface */
static plane_t findplane(vector<face_t*> &m,brush_t *br)
{
  int opt=-1,o;
  int a,b,c,oa,ob;
  plane_t rp;
  plane_t mp;

  int step=1;
  unsigned int s=m.size();
  
  /*if(opbfm) {
    step=m->nbr/opbfm;
    if(step<1) step=1;
    }*/

  // optimser ?: utiliser que les plans presents
  for(unsigned int i=0;i<s;i+=step) {
    a=b=0;
    mp=m[i]->p.opp();
    for(unsigned int k=0;k<s;k+=step) {
      if(i!=k) {
	//if((m[i]->p==m[k]->p) || (mp==m[k]->p)) {if(i>k) {a=-1;break;}}
	//else {
	  c=m[k]->checkIntersectFace(&(m[i]->p));
	  if(c==-1) {if(i>k) {a=-1;break;}}
	  if(c==0) a++;
	  if(c==1) b++;
	  if(c==2) {a++;b++;}
	  if(opt!=-1 && (a*a+b*b)>=opt) break;
	  //}
      }
    }

    if(a>=0) {
      o=a*a+b*b;
      if(/*a && b && */(opt==-1 || o<opt)) 
	{
	  rp=m[i]->p;
	  opt=o;oa=a;ob=b;
	}
    }
  }
  
  if(opt>=0) {
    //printf("plane %d (%d / %d)\n",rp,oa,ob);
    return rp;
  }

  /*
  for(j=0;j<m->tab[0]->nbr;j++) {
    for(i=0;i<br->nbr;i++) {
      if(br->tab[i].p==m->tab[0]->tab[j].p) 
	break;
    }
    if(i==br->nbr) {
      rp=m->tab[0]->tab[j].p;
      return rp;
    }
  }
  printf("%d brush\n",m->nbr);
  for(i=0;i<m->nbr;i++) {
    printf("type=%d\n",m->tab[i]->type);
    printBrush(m->tab[i]);
  }
  */

  Error(" ");
}

/* 
return the bsp leaf if the map have not to be cutted
NULL if not 
*/

///FIX
static int isleaf(vector<face_t*> &m,brush_t *b)
{
  unsigned int i,j;
  
  return (m.size()<1);
  
  for(i=0;i<m.size();i++) {
    for(j=0;j<b->tab.size();j++) {
      if(b->tab[j].p==m[i]->p ||
	 b->tab[j].p==m[i]->p.opp()) break;
    }
    
    if(j==b->tab.size()) return 0;
  }
  return 1;
  
  /*
  // leaf
  {
    bsp_t *bsp=(bsp_t*)malloc(sizeof(bsp_t));
    bsp->leaf=1;
    
    //bsp->type=TYPE_SOLID;
    //bsp->fog=0;
    bsp->brush=b;
    
    // FREE m
    for(i=0;i<m->nbr;i++)
      destroyFace(m->tab[i]);
    free(m);
    
    return bsp;
  }
  */
}

static void updateprt(bsp_t *b,vector<face_t*> &m3)
{
  vector<portal_t*> lp0,lp1;
  bsp_t *b0=b->child[0],*b1=b->child[1];
  plane_t p=b->plane;
  plane_t mp=p.opp();
  

  // cut portals
  unsigned int i;
  for(;b->portals.size()>0;b->portals.pop_back()) {
    portal_t *pr=b->portals[b->portals.size()-1],*p1,*p2;
    bsp_t *ob=pr->bsp[pr->bsp[0]==b];

    cutPortalByPlane(pr,&p1,&p2,&p);
    if(p1!=NULL) {
      if(p1->bsp[0]==b)
	p1->bsp[0]=b0;
      else
	p1->bsp[1]=b0;
      // ... ?

      b0->portals.push_back(p1);
      
    }
    if(p2!=NULL) {
      if(p2->bsp[0]==b)
	p2->bsp[0]=b1;
      else
	p2->bsp[1]=b1;

      b1->portals.push_back(p2);
    }
    
    //remplace pr by p1 and p2 in ob
    for(unsigned int j=0;j<ob->portals.size();j++) {
      if(ob->portals[j]==pr) {
	if(p1) ob->portals[j]=p1;
	else ob->portals[j]=p2;
	break;
      }
    }
    if(p1 && p2) {
      ob->portals.push_back(p2);
    }
  }

  // add new protal with m3
  // create portal
  portal_t *port=new portal_t;//(&p);
  port->face=face_t(&p);

  for(i=0;i<b->brush->tab.size();i++)
    port->face.cutByPlane(&b->brush->tab[i].p);

  if(port->face.tab.size()<=0) Error("empty portal");
  
  port->bsp[0]=b0;
  port->bsp[1]=b1;
  port->listfaces=m3;

  // add to lp0 and lp1
  b0->portals.push_back(port);
  b1->portals.push_back(port);
}

/* recursivly build the bsp */
static void buildbspfaces_rec(vector<face_t*>&lf,bsp_t *b)
{
  bsp_t *b0,*b1;
  brush_t *brush0,*brush1;
  vector<face_t*> m1,m2,m3;
  
  if(b->brush->tab.size()<=0) Error("empty brush");
  if(b->brush->tab.size()>=12)
    Warn("brush avec %d faces",b->brush->tab.size()); 
  
  // check if the bsp has to be cutted again
  if(isleaf(lf,b->brush)) {
    //...
    return;
  }
  
  // find a good cutting plane
  plane_t p=findplane(lf,b->brush);
  plane_t mp=p.opp();

  b->leaf=0;
  b->plane=p;
  
  // create the 2 brushes for the sons
  // destroy the current brush for memory
  
  cutlistface(lf,m1,m2,m3,&p);
  
  // create sons 

  b0=new bsp_t;
  b1=new bsp_t;
  b0->leaf=b1->leaf=1;
  b->child[0]=b0;
  b->child[1]=b1;

  updateprt(b,m3);

  brush0=b->brush;//new brush_t(*(b->brush));
  brush1=new brush_t(*(b->brush));
  brush0->cutByPlane(&p);
  brush1->cutByPlane(&mp);
  b->brush=NULL;
  
  b0->brush=brush0;
  b1->brush=brush1;

  // rec
  buildbspfaces_rec(m1,b0);
  buildbspfaces_rec(m2,b1);
}

hstr_t *buildbspfaces(vector<face_t*> &lf)
{
  printf("--- BSP & PORTALIZE ---\n");

  hstr_t *h=new hstr_t;

  bsp_t *b=new bsp_t;
  b->brush=new brush_t;
  b->leaf=1;
  
  h->bsp=b;
  h->ext=new bsp_t();
  h->ext->leaf=1;
  h->ext->brush=new brush_t;
  
  // add protals betwen b->brush and ext->brush
  for(unsigned int i=0;i<b->brush->tab.size();i++) {
    portal_t *p=new portal_t;
    p->face=b->brush->tab[i];
    p->bsp[0]=b;
    p->bsp[1]=h->ext;
    b->portals.push_back(p);
    h->ext->portals.push_back(p);
  }
  
  buildbspfaces_rec(lf,b);
  
  //printf("ext: %d portals\n",h->ext->portals.size());
  return h;
}


static void reconsbsp_rec(bsp_t *b)
{
  if(b->leaf==1){
    //b->brush->print();
    return;
  }

  bsp_t *b0,*b1;
  brush_t *brush0,*brush1;
  
  plane_t p=b->plane;
  plane_t mp=p.opp();

  b0=b->child[0];
  b1=b->child[1];

  //  vector<face_t*> m3;
  //  updateprt(b,m3);
  
  brush0=b->brush;
  brush1=new brush_t(*(b->brush));
  brush0->cutByPlane(&p);
  brush1->cutByPlane(&mp);
  
  b->brush=NULL;
  b0->brush=brush0;
  b1->brush=brush1;

  reconsbsp_rec(b0);
  reconsbsp_rec(b1);
}

void reconsBsp(hstr_t *h)
{
  if(h->bsp->brush!=NULL) Warn("brush != NULL");
  h->bsp->brush=new brush_t;
  
  //h->ext=new bsp_t();
  //h->ext->leaf=1;
  //h->ext->brush=new brush_t;
  
#if 0
  // add protals betwen h->bsp->brush and ext->brush
  for(unsigned int i=0;i<h->bsp->brush->tab.size();i++) {
    portal_t *p=new portal_t;
    p->face=h->bsp->brush->tab[i];
    p->bsp[0]=h->bsp;
    p->bsp[1]=h->ext;
    h->bsp->portals.push_back(p);
    h->ext->portals.push_back(p);
  }
#endif
  
  reconsbsp_rec(h->bsp);
}

/*** stats ***/

static int nbrbspnode(bsp_t *b)
{
  if(b->leaf) return 1;
  else return 1+nbrbspnode(b->child[0])+ nbrbspnode(b->child[1]);
}


static int bspheight(bsp_t *b)
{
  if(b->leaf) return 0;
  else return 1+max(bspheight(b->child[0]),bspheight(b->child[1]));
}

void printbspstat(bsp_t *b)
{
  std::cout << nbrbspnode(b) << " nodes, ";
  std::cout << "height: " << bspheight(b) << endl;
} 


