#ifndef _face_hpp_
#define _face_hpp_

#include "plane.hpp"
#include <vector>
using namespace std;
#include "text.hpp"
#include "vector_.hpp"

#define minmaxb 65536
#define MAXPOINTSBYFACE 100

#define FACE_MARK 1

#define FACE_ZONE 256
#define FACE_BLOCK 128
#define FACE_DRAW 64

class face_t {
public:
  face_t();
  face_t(plane_t *p);
  face_t(const face_t &);
  ~face_t();
  const face_t & operator =(const face_t &a);

  void reverse();
  void cutByPlane(plane_t *p);
  void print() const;
  int checkIntersectFace(plane_t *p) const;
  double aera();

  void save(ofstream &) const;
  void load(ifstream &);

  plane_t p;
  
  vector_stat<hedge_t> tab;

  void insert(unsigned int,vertex_t &);
  void test() const;

  /*******/
  
  int flags;
  int i0;
  // + infos (texture...)
  text_t text;
  int num; //ident unique

  static unsigned long long int nbr_mem;
};

extern void loadVectorFace(vector<face_t*> &v,char *f);
extern void saveVectorFace(vector<face_t*> &v,char *f);
extern void destroyVectorFace(vector<face_t*> &v);
extern void interEdgePlane_(vertex_t *a,vertex_t *b,vertex_t *c,plane_t *p);

#endif
