#include "he.hpp"
#include "portal.hpp"

struct cor_hedge_t {
  //vertex_t v1,v2;
  int op;
  vector<hedge2_t> listcor;
};

static vector<cor_hedge_t> listhedge;

static void corhedge(hedge2_t &e)
{
  unsigned int i;
  for(i=0;i<listhedge.size();i++) {
    if(e.v1==listhedge[i].listcor[0].v1 && e.v2==listhedge[i].listcor[0].v2) break;
  }
  int s=listhedge.size();
  if(i==(unsigned int)s) {
    //new
    cor_hedge_t ch;
    int j;
    for(j=0;j<s;j++) {
      if(e.v2==listhedge[j].listcor[0].v1 && e.v1==listhedge[j].listcor[0].v2) break;
    }
    if(j==s) j=-1;
    ch.op=j;
    if(j>=0) listhedge[j].op=i;    
    listhedge.push_back(ch);
  }

  //add
  listhedge[i].listcor.push_back(e);
}

static void corhedge(vector<hedge2_t> &v)
{
  for(unsigned int i=0;i<v.size();i++)
    corhedge(v[i]);
}

static void addhedge(vertex_t &a, vertex_t &b,unsigned int f,unsigned int ii,vector<hedge2_t> &v)
{
  hedge2_t ch;
  ch.v1=a;
  ch.v2=b;
  ch.f=f;
  ch.i=ii;
  
  v.push_back(ch);
}

static void listhedge2_leaf(bsp_t *b,vector<hedge2_t> &v,bool limit)
{
  for(unsigned int i=0;i<b->portals.size();i++) { 
    portal_t *p=b->portals[i];
    if((b==p->bsp[0]) && (limit==false || p->flag & PRT_ZONE))
      for(unsigned int j=0;j<p->listfaces.size();j++) {
	if(p->listfaces[j]->flags & FACE_DRAW) {
	  face_t *f=p->listfaces[j];
	  for(unsigned int k=0;k<f->tab.size();k++) 
	    addhedge(f->tab[k],f->tab[(k+1)%f->tab.size()],f->num,k,v);
	}
      }
  }
}

void listhedge2_r(bsp_t *b,vector<hedge2_t> &v,bool limit)
{
  if(b->leaf) {
    listhedge2_leaf(b,v,limit);
  } else {
    listhedge2_r(b->child[0],v,limit);
    listhedge2_r(b->child[1],v,limit);
  }
}

// FIX ? on suppose que il n'y a pas de faces dans les portals adj a ext
void numface_r(bsp_t *b,int &numptr,int zone)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) { 
      portal_t *p=b->portals[i];
      //if(b==p->bsp[0]) 
      for(unsigned int j=0;j<p->listfaces.size();j++) {
	// FIX normalement faudrait numeroter toutes les faces qui apparaissent dans la map finale
	if(p->listfaces[j]->flags & FACE_DRAW) {
	  vec_t d=vec3DotProduct(p->listfaces[j]->p.n,p->face.p.n);
	  if(((d>0.) && b==p->bsp[0]) || ((d<0.) && b==p->bsp[1])) {
	    face_t *f=p->listfaces[j];
	    numptr++;//.push_back(f);
	    f->num=(zone<<BITFORNUM)+numptr-1;
	    for(unsigned int k=0;k<f->tab.size();k++) { 
	      f->tab[k].f=(zone<<BITFORNUM)+f->num;
	      f->tab[k].ind=k;
	    }
	  }
	}
      }
    }
  } else {
    numface_r(b->child[0],numptr,zone);
    numface_r(b->child[1],numptr,zone);
  }
}

static void numface_r_(bsp_t *b,vector<face_t *> &numptr,int zone)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) { 
      portal_t *p=b->portals[i];
      if(b==p->bsp[0]) 
	for(unsigned int j=0;j<p->listfaces.size();j++) {
	  if(p->listfaces[j]->flags & FACE_DRAW) {
	    face_t *f=p->listfaces[j];
	    unsigned int n=MASKNUM&f->num;
	    if(n>=numptr.size()) numptr.resize(n+1);
	    numptr[n]=f;
	  }
	}
    }
  } else {
    numface_r_(b->child[0],numptr,zone);
    numface_r_(b->child[1],numptr,zone);
  }
}

void halfedge(hstr_t *h, vector<hedge2_t> lext,int zone)
{
  // vector pour correspondance num <=> pointeur
  vector<face_t *> numptr;
  
  // construit vecteur numptr
  numface_r_(h->bsp,numptr,zone);
  
  // maj des op dans halfedge si possible 
  vector<hedge2_t> v;
  listhedge2_r(h->bsp,v);

  corhedge(v);
  corhedge(lext);

  // warn si un n'a pas d opposite
  unsigned int i;

  for(i=0;i<listhedge.size();i++) {
    //printf("%d %d %d\n",listhedge[i].listcor[0].f>>BITFORNUM,listhedge[i].listcor[0].f&MASKNUM,listhedge[i].listcor[0].i);
#if 1
    if(listhedge[i].op!=-1 && listhedge[i].listcor.size()==1 && 
       listhedge[listhedge[i].op].listcor.size()==1) {
      if((listhedge[i].listcor[0].f>>BITFORNUM)==(unsigned int)zone) {
	numptr[MASKNUM&listhedge[i].listcor[0].f]->
	  tab[listhedge[i].listcor[0].i].op=
	  listhedge[listhedge[i].op].listcor[0].f;
	numptr[MASKNUM&listhedge[i].listcor[0].f]->
	  tab[listhedge[i].listcor[0].i].indop=
	  listhedge[listhedge[i].op].listcor[0].i;
      }
    }
    else {
      Warn(" ");
      if(listhedge[i].listcor.size()!=1) 
	Warn("listcor %d == %d",i,listhedge[i].listcor.size());
      if(listhedge[i].op==-1) 
	Warn("op %d == -1",i);
    }
#endif
  }
  
  // destroy listhedge
  for(i=0;i<listhedge.size();i++) {
    listhedge[i].listcor.resize(0);
  }
  listhedge.resize(0);
}

/***********/

void heinzone(bsp_t *b,vector<hedge2_t> &vv,vector<hedge2_t> &vv2)
{
  if(b->leaf) {
    if(b->id!=-1)
      while(vv.size()) {
	hedge2_t h=vv[vv.size()-1];
	vv.pop_back();
	vv2.push_back(h);
      }
  } else {
    vector<hedge2_t> v1,v2;
    while(vv.size()) {
      hedge2_t h=vv[vv.size()-1];
      vv.pop_back();
      int d=b->plane.checkVertex(&h.v1);
      if(d>0) v1.push_back(h);
      if(d<0) v2.push_back(h);
      if(d==0){
	d=b->plane.checkVertex(&h.v2);
	if(d>=0) v1.push_back(h);
	else v2.push_back(h);
      }
    }
    heinzone(b->child[0],v1,vv2);
    
    while(v1.size()) {
      hedge2_t h=v1[v1.size()-1];
      v1.pop_back();
      int d=b->plane.checkVertex(&h.v1);
      if(d==0){
	d=b->plane.checkVertex(&h.v2);
	if(d<=0) v2.push_back(h);
	else vv.push_back(h);
      } else vv.push_back(h);
    }
    heinzone(b->child[1],v2,vv2);
    
    while(v2.size()) {
      hedge2_t h=v2[v2.size()-1];
      v2.pop_back();
      vv.push_back(h);
    }
  }
}

void helimzone(bsp_t *b,vector<hedge2_t> &vv,vector<hedge2_t> &vv2)
{
  if(b->leaf) {
    if(b->id==-1)
      while(vv.size()) {
	hedge2_t h=vv[vv.size()-1];
	vv.pop_back();
	vv2.push_back(h);
      }
  } else {
    vector<hedge2_t> v1,v2;
    while(vv.size()) {
      hedge2_t h=vv[vv.size()-1];
      vv.pop_back();
      int d=b->plane.checkVertex(&h.v1);
      if(d>0) v1.push_back(h);
      if(d<0) v2.push_back(h);
      if(d==0){
	d=b->plane.checkVertex(&h.v2);
	if(d>=0) v1.push_back(h);
	else v2.push_back(h);
      }
    }
    helimzone(b->child[0],v1,vv2);
    
    while(v1.size()) {
      hedge2_t h=v1[v1.size()-1];
      v1.pop_back();
      int d=b->plane.checkVertex(&h.v1);
      if(d==0){
	d=b->plane.checkVertex(&h.v2);
	if(d<=0) v2.push_back(h);
	else vv.push_back(h);
      } else vv.push_back(h);
    }
    helimzone(b->child[1],v2,vv2);
    
    while(v2.size()) {
      hedge2_t h=v2[v2.size()-1];
      v2.pop_back();
      vv.push_back(h);
    }
  }
}

/***********/

void saveVectorHE(vector<hedge2_t> &v,char *f)
{
  ofstream ou(f,ofstream::binary|ofstream::out);
  unsigned int i=v.size();

  ou.write((char*)&i,sizeof(i));
  
  for(i=0;i<v.size();i++)
    v[i].save(ou);

  ou.close();
}

void loadVectorHEAppend(vector<hedge2_t> &v,char *f)
{
  ifstream in(f,ifstream::binary|ifstream::in);
  unsigned int i;

  in.read((char*)&i,sizeof(i));

  unsigned int d=v.size();
  unsigned int s=i;
  v.resize(v.size()+i);
  for(i=0;i<s;i++) {
    v[d+i].load(in);
  }

  in.close();
}






