#ifndef _HE_HPP_
#define _HE_HPP_

#include "bsp.hpp"
#include <vector>
using namespace std;

struct hedge2_t {
  vertex_t v1,v2;
  unsigned int f;
  unsigned int i;

  void save(ofstream &ff) const {
    v1.save(ff); 
    v2.save(ff); 
    ff.write((char*)&f,sizeof(f));
    ff.write((char*)&i,sizeof(i));
  }
  void load(ifstream &ff) {
    v1.load(ff);
    v2.load(ff);
    ff.read((char*)&f,sizeof(f));
    ff.read((char*)&i,sizeof(i));
  }
};

extern void loadVectorHEAppend(vector<hedge2_t> &v,char *f);
extern void saveVectorHE(vector<hedge2_t> &v,char *f);

//extern void listhedge_r(bsp_t *b);
extern void halfedge(hstr_t *h, vector<hedge2_t> lext,int zone);
extern void listhedge2_r(bsp_t *b,vector<hedge2_t> &v,bool limit=false);

extern void heinzone(bsp_t *b,vector<hedge2_t> &vv,vector<hedge2_t> &vv2);
extern void helimzone(bsp_t *b,vector<hedge2_t> &vv,vector<hedge2_t> &vv2);
extern void numface_r(bsp_t *b,int &numptr,int zone);

#endif
