#include "integer.hpp"
#include <stdio.h>
#include "math.h"

typedef signed long long int int64_t;

int64_t lcm_i(int64_t a,int64_t b);
int64_t gcd_i(int64_t a,int64_t b);

#ifdef GMP

#ifdef GMPMIX
unsigned long long int int__t::nbrop=0;
unsigned long long int int__t::nbrgop=0;
unsigned long long int int__t::nbr=0;

std::ostream & operator<<(std::ostream &o, const int__t &z)
{
  if(z.b==0)
    return o << z.i;
  else {
    char *s=mpz_get_str(NULL,10,*(z.mpz));
    return o << "(gmp) " << s;
    free(s);
    return o;
  }
}

void int__t::stat()
{
  printf("stat int__t : %Ld / %Ld\n",nbrop,nbrgop);
}


int__t gcd(const int__t &aa,const int__t &bb)
{
  if (aa.b==0 && bb.b==0) {
    return int__t(gcd_i(aa.i,bb.i));
  }

  if(aa.mpz==NULL) aa.convert();
  if(bb.mpz==NULL) bb.convert();

  int__t c;
  c.b=1;
  c.mpz=(mpz_t*)malloc(sizeof(mpz_t));
  mpz_init(*(c.mpz));

  mpz_gcd(*(c.mpz),*(aa.mpz),*(bb.mpz));
    
  return c;
}

int__t lcm(const int__t &aa,const int__t &bb)
{
  if (aa.b==0 && bb.b==0) {
    int64_t t=gcd_i(aa.i,bb.i);
    float ff=aa.f*bb.f/t;
    if(fabs(ff) < MAXFF)
      //return int__t(lcm_i(aa.i,bb.i));
      return int__t(aa.i/t*bb.i);
  }

  if(aa.mpz==NULL) aa.convert();
  if(bb.mpz==NULL) bb.convert();

  int__t c;
  c.b=1;
  c.mpz=(mpz_t*)malloc(sizeof(mpz_t));
  mpz_init(*(c.mpz));

  mpz_lcm(*(c.mpz),*(aa.mpz),*(bb.mpz));
    
  return c;
}

#endif

#if 0

int__t gcd(int__t a,int__t b)
{
  int__t c;
  mpz_gcd(c.get_mpz_t(),a.get_mpz_t(),b.get_mpz_t());
  return c;
}

int__t lcm(int__t a,int__t b)
{
  int__t c;
  mpz_lcm(c.get_mpz_t(),a.get_mpz_t(),b.get_mpz_t());
  return c;
}


#endif
//#else


int64_t gcd_i(int64_t a,int64_t b)
{
  char t=0;
  int64_t u;

  if(a<0) a=-a;
  if(b<0) b=-b;

  if(a==0) return b;
  if(b==0) return a;

  while((!(a&1)) && (!(b&1))) {t++;a>>=1;b>>=1;}
  while(!(a&1)) a>>=1;
  while(!(b&1)) b>>=1;
  
  while(a!=b) {
    while(a<b) {
      b-=a;
      while(!(b&1)) b>>=1;
    }
    u=a;a=b;b=u;
  }
  return a<<t;
}

int64_t lcm_i(int64_t a,int64_t b)
{
  return (a/gcd_i(a,b))*b;
}

#endif

int__t iabs(int__t a)
{
  if(a<0) return -a;
  else return a;
}

int__t strToInt(char *c)
{
  int__t i=0;
  while(*c) {
    i*=10;
    i+=(int)(*c-'0');
    c++;
  }
  return i;
}
