#ifndef _map_hpp_
#define _map_hpp_

#include <string.h>
#include <vector>
using namespace std;
#include "brush.hpp"

class bsp_t;

#define READMAP_ZONE 1

struct entit_t {
  entit_t():name(NULL) {}
  entit_t(const char *n):name(strdup_(n)) {}
  ~entit_t() {if(name) free(name);}
  void setname(const char*n) {
    if(name) free(name);
    if(n) name=strdup_(n); else name=NULL;
  }

  vec3_t pos;
  vec3_t dir;
  char *name;
};


struct map_t {
  map_t() {}
  ~map_t() {}
  
  //unsigned int nbrbr, nbrfa;
  vector<brush_t*> tabbr;
  vector<face_t*> tabfa;
  vector<entit_t*> tabent;
};


extern void readMapBspZ(bsp_t *,int);

extern map_t *readMap(map_t *m,const char *filename,int flag=0,vec_t tx=0,vec_t ty=0,vec_t tz=0);
extern map_t *readSCR(map_t *m,const char *filename,int flag,vec_t tx,vec_t ty,vec_t tz);
extern map_t *readTRUC(map_t *m,const char *filename,int flag,vec_t tx,vec_t ty,vec_t tz);
extern map_t *readMAP(map_t *m,const char *filename,int flag,vec_t tx,vec_t ty,vec_t tz);

//extern void writeMap(map_t *m,const char*); //ecrit uniquement les brushes
extern void writeTruc(vector<face_t*> &t,char *filename,int=0);

extern void brushesToFaces(map_t *m);



#endif
