#ifndef _plane_hpp_
#define _plane_hpp_

/* OK */

#include "vertex.hpp"
#include "vect.hpp"

#include <fstream>

struct portal_s;
//struct he_vertex_s;

class plane_t {
public:

  vec4_t n;

  void print() const;
  int checkVertex(const vertex_t *v) const;

  bool operator==(const plane_t &);
  plane_t opp() const;

  void norm() {
    vec_t h;
    h=n[0]*n[0]+n[1]*n[1]+n[2]*n[2];
    h=asqrt(h);
    for(int i=0;i<4;i++)
      n[i]/=h;
  }
  
  void save(ofstream &f) const {for(unsigned int i=0;i<4;i++) saveVec(f,n[i]);}
  void load(ifstream &f) {for(unsigned int i=0;i<4;i++) n[i]=loadVec(f);}
};

extern void pointsToPlane(const vec3_t pts[3],plane_t *p);
extern void vertexToPlane(const vertex_t *a, const vertex_t *b, const vertex_t *c, plane_t *p);

#endif




