#include "portal.hpp"
#include "utils.hpp"
#include "brush.hpp"

#include <stdio.h>

portal_t::portal_t()
  :face() //,listfaces(NULL)
{
  bsp[0]=bsp[1]=NULL;
}

portal_t::~portal_t()
{
}

void portal_t::remove()
{
  for(unsigned int i=0;i<2;i++) {
    bsp_t *b=bsp[i];
    if(b) {
      for(unsigned int j=0;j<b->portals.size();j++)
	if(this==b->portals[j]) {
	  b->portals[j]=b->portals[b->portals.size()-1];
	  b->portals.pop_back();
	  break;
	}
    }
  }
  for(;listfaces.size();listfaces.pop_back())
    delete listfaces[listfaces.size()-1];
}

const portal_t & portal_t::operator =(const portal_t &a)
{
  if(this != &a) {
    face=a.face;
    bsp[0]=a.bsp[0];
    bsp[1]=a.bsp[1];
    listfaces=a.listfaces;
  }
  return *this;
}

void cutPortalByPlane(portal_t *a,portal_t **b,portal_t **c,plane_t *p)
/* destroy a */
{
  face_t *ft,*ft1;
  plane_t mp=p->opp();
  
  if(a->face.tab.size()<=0) Error(" ");

  *b=new portal_t;
  *c=new portal_t;

  **b=*a;
  **c=*a;
  (*b)->listfaces.resize(0);
  (*c)->listfaces.resize(0);

  (*b)->face.cutByPlane(p);
  (*c)->face.cutByPlane(&mp);

  if((*b)->face.tab.size()<=0) {
    (*c)->listfaces=a->listfaces;
    delete *b;
    *b=NULL;
    delete a;
    return;
  }
  
  if((*c)->face.tab.size()<=0) {
    (*b)->listfaces=a->listfaces;
    delete a;
    delete *c;
    *c=NULL;
    return;
  }


  for(;a->listfaces.size()>0;a->listfaces.pop_back()) {
    ft=new face_t(*(a->listfaces[a->listfaces.size()-1]));
    ft1=a->listfaces[a->listfaces.size()-1];
    
    ft->cutByPlane(p);
    ft1->cutByPlane(&mp);
    
    if(ft->tab.size()>0) {
      (*b)->listfaces.push_back(ft);
    } 
    else delete ft;
    
    if(ft1->tab.size()>0) {
      (*c)->listfaces.push_back(ft1);
    } 
    else delete ft1;
  }
  
  delete a;
}



/*************/

void bspId(bsp_t *b,int m)
{
  if(b->leaf) {
    b->id=m;
  } else {
    bspId(b->child[0],m);
    bspId(b->child[1],m);
  }
}


void bspMaskPrt(bsp_t *b,int mo,int ma)
{
  if(b->leaf) {
    unsigned int i;
    for(i=0;i<b->portals.size();i++)
      b->portals[i]->flag=(b->portals[i]->flag & ma) | mo;
  } else {
    bspMaskPrt(b->child[0],mo,ma);
    bspMaskPrt(b->child[1],mo,ma);
  }
}

void bspUnMarkPrt(bsp_t *b)
{
  bspMaskPrt(b,0,~PRT_MARK);
}

void bspPrt(bsp_t *b)
{
  if(b->leaf) {
    unsigned int i,j;
    for(i=0;i<b->portals.size();i++) {
      if(!(b->portals[i]->flag & PRT_MARK)) {
	portal_t *p=b->portals[i];
	for(j=0;j<p->listfaces.size();j++) {
	  // ZONE
	  if(p->listfaces[j]->flags & FACE_ZONE) {
	    //if(p->listfaces[j]->aera() >= p->face.aera()/(vec_t)2) 
	    p->flag|= PRT_ZONE;
	  }

	  // BLOCK
	  if(p->listfaces[j]->flags & FACE_BLOCK) {
	    //if(p->listfaces[j]->aera() >= p->face.aera()/(vec_t)2) 
	    p->flag|= PRT_BLOCK;
	  }
	  
	  /*
	  // DRAW (pas forcement bloquante)
	  if(p->listfaces[j]->flags & FACE_DRAW) {
	    //if(p->listfaces[j]->aera() >= p->face.aera()/(vec_t)2) 
	    p->flag|= PRT_DRAW;
	    //printf("coucou\n");
	  }
	  */
	}
	b->portals[i]->flag=b->portals[i]->flag | PRT_MARK;
      }
    }
  } else {
    bspPrt(b->child[0]);
    bspPrt(b->child[1]);
  }
}

static void floodzone_r(bsp_t *b, int m, int prt)
{
#ifdef DEBUG
  if(b->leaf==0) Error("b not a leaf");
#endif
  
  if(b->id!=m) {
    b->id=m;
    for(unsigned int i=0;i<b->portals.size();i++) {
      if(   (!(prt & PRT_ZONE)  || (!(b->portals[i]->flag & PRT_ZONE)))
	 && (!(prt & PRT_BLOCK) || (!(b->portals[i]->flag & PRT_BLOCK)))) {
	if(b==b->portals[i]->bsp[0]) 
	  floodzone_r(b->portals[i]->bsp[1],m,prt);
	else
	  floodzone_r(b->portals[i]->bsp[0],m,prt);
      }
    }
  }
}

void flood(bsp_t *b, int m, int prt)
{
  floodzone_r(b,m,prt);
}

static bsp_t *findbrush(bsp_t *b, int m)
{
#ifdef DEBUG
  if(b==NULL) Error("b==NULL");
#endif
  if(b->leaf) {
    if(b->id==m)
      return b;
    else 
      return NULL;
  } else {
    bsp_t *br=NULL;
    if((br=findbrush(b->child[0],m))==NULL)
       br=findbrush(b->child[1],m);
    return br;
  }
}

int floodZone(hstr_t *h)
{
  bsp_t *b;
  int nbrz=0;

  //floodzone_r(h->ext,0,0);

  bspId(h->bsp,0);
  h->ext->id=0;

  floodzone_r(h->ext,-1,PRT_ZONE);
  
  // tant que il y a une zone de id =0, on flood
  while((b=findbrush(h->bsp,0))!=NULL)
    floodzone_r(b,++nbrz,PRT_ZONE);
  
  printf("%d zones\n",nbrz);

  return nbrz;
}

/******************************/

void portal_t::load(ifstream &f)
{
  bsp[0]=bsp[1]=NULL;
  
  //destroy faces
  unsigned int i=0;
  for(i=0;i<listfaces.size();i++)
    delete listfaces[i];
  
  f.read((char*)&(bspid),sizeof(bspid));
  f.read((char*)&(flag),sizeof(flag));

  face.load(f);
  
  f.read((char*)&i,sizeof(i));
  listfaces.resize(i);
  for(i=0;i<listfaces.size();i++) {
    listfaces[i]=new face_t;
    listfaces[i]->load(f);
  }
}


void portal_t::save(ofstream &ou) const 
{
  ou.write((char*)&(bspid),sizeof(bspid));
  ou.write((char*)&(flag),sizeof(flag));

  face.save(ou);

  unsigned int i=listfaces.size();

  ou.write((char*)&i,sizeof(i));
  for(i=0;i<listfaces.size();i++)
    listfaces[i]->save(ou);
}
