#include "pvsstab.hpp"
#include <stdio.h>
#include <stdlib.h>

//#define AFFPVSSTAB

static vec_t det3(vec3_t a,vec3_t b,vec3_t c)
{
  return a[0]*(b[1]*c[2]-b[2]*c[1])
    +a[1]*(b[2]*c[0]-b[0]*c[2])
    +a[2]*(b[0]*c[1]-b[1]*c[0]);
}

static bool fourlines(vec3_t tab[4][2], vec3_t res[2][2])
{
  unsigned int i;
  vec3_t tv[4];

  for(i=0;i<4;i++) {
    vec3Copy(tab[i][1],tv[i]);
    vec3Sub_(tab[i][0],tv[i]);
  }

  //a= t[0][0] + alpha tv[0]
  //b= t[1][0] + alpha' tv[1]
  // det(tv[2],a-tab[2][0],b-tab[2][0])=0

  vec3_t u,v;
  vec3Copy(tab[0][0],u);
  vec3Sub_(tab[2][0],u);
  vec3Copy(tab[1][0],v);
  vec3Sub_(tab[2][0],v);

  vec_t p,q,r,s;
  p=det3(tv[2],u,v);
  q=det3(tv[2],tv[0],v);
  r=det3(tv[2],u,tv[1]);
  s=det3(tv[2],tv[0],tv[1]);

  vec3Copy(tab[0][0],u);
  vec3Sub_(tab[3][0],u);
  vec3Copy(tab[1][0],v);
  vec3Sub_(tab[3][0],v);

  vec_t pp,qq,rr,ss;
  pp=det3(tv[3],u,v);
  qq=det3(tv[3],tv[0],v);
  rr=det3(tv[3],u,tv[1]);
  ss=det3(tv[3],tv[0],tv[1]);

  if(fabs(s)<fabs(ss)) {
    vec_t ex;
    ex=p;p=pp;pp=ex;    
    ex=q;q=qq;qq=ex;    
    ex=r;r=rr;rr=ex;    
    ex=s;s=ss;ss=ex;
  }
  
  if(s!=0.) {
    vec_t lala;
    lala=ss/s;
    pp-=p*lala;
    qq-=q*lala;
    rr-=r*lala;
    ss-=s*lala;
  }

  vec_t al;
  vec_t alp;

#ifdef AFFPVSSTAB
  printf("rr= %f qq=%f s=%f\n",rr,qq,s);
#endif
  if(rr==0.) return false;

  //alp=(-pp-al*qq)/rr;
  //p+al*q+(-pp-al*qq)/rr*(r+al*s)=0
  //p+ al*q - pp/rr*r - pp/rr*al*s - al*qq/rr*r - al^2*qq/rr*s
  //p- pp/rr*r + al*(q - pp/rr*s - qq/rr*r ) - al^2*qq/rr*s

  //FIX ??????

  if(qq*s==0.) {
    // p- pp/rr*r + al*(q - pp/rr*s - qq/rr*r )=0;
    if(q - pp/rr*s - qq/rr*r==0.) {
#ifdef AFFPVSSTAB
      printf("qq*s==0. div 0.\n");
#endif
      return false;
    }
    al=(-p+ pp/rr*r)/(q - pp/rr*s - qq/rr*r);
    alp=(-pp-al*qq)/rr;

#ifdef AFFPVSSTAB
    printf("qq*s==0.\n");
#endif    

    vec3Copy(tv[0],res[0][0]);
    vec3Scale_(al,res[0][0]);
    vec3Add_(tab[0][0],res[0][0]);
    vec3Copy(tv[1],res[0][1]);
    vec3Scale_(alp,res[0][1]);
    vec3Add_(tab[1][0],res[0][1]);
    vec3Copy(res[0][0],res[1][0]);
    vec3Copy(res[0][1],res[1][1]);

    return true;
  }

  vec_t delta=(q-pp/rr*s-qq/rr*r)*(q-pp/rr*s-qq/rr*r)+4.*qq/rr*s*(p-pp/rr*r);
#ifdef AFFPVSSTAB
  printf("delta=%f\n",delta);
#endif
  if(delta>-EPSILON && delta<0.) delta=0.;
  if(delta>=0.) { 
    al=-(-(q - pp/rr*s - qq/rr*r )+sqrt(delta))/2./(qq/rr*s);
    alp=(-pp-al*qq)/rr;
#ifdef AFFPVSSTAB
    printf("al=%f alp=%f\n",al,alp);
    printf("= %f\n",p+al*q+alp*r+al*alp*s);
#endif

    vec3Copy(tv[0],res[0][0]);
    vec3Scale_(al,res[0][0]);
    vec3Add_(tab[0][0],res[0][0]);
    vec3Copy(tv[1],res[0][1]);
    vec3Scale_(alp,res[0][1]);
    vec3Add_(tab[1][0],res[0][1]);
      
    al=-(-(q - pp/rr*s - qq/rr*r )-sqrt(delta))/2./(qq/rr*s);
    alp=(-pp-al*qq)/rr;
#ifdef AFFPVSSTAB
    printf("al=%f alp=%f\n",al,alp);
    printf("= %f\n",p+al*q+alp*r+al*alp*s);
#endif

    vec3Copy(tv[0],res[1][0]);
    vec3Scale_(al,res[1][0]);
    vec3Add_(tab[0][0],res[1][0]);
    vec3Copy(tv[1],res[1][1]);
    vec3Scale_(alp,res[1][1]);
    vec3Add_(tab[1][0],res[1][1]);
    
    return true;
  } else {
    return false;
  }
}

static bool pointtwolines(vec3_t v,vec3_t tab[2][2],vec3_t res[2])
{
  vec3_t tv[2];
  unsigned int i;
  
  for(i=0;i<2;i++) {
    vec3Copy(tab[i][1],tv[i]);
    vec3Sub_(tab[i][0],tv[i]);
  }

  vec3Copy(v,res[0]);

  //r[0][1]=tab[0][0]+al*tv[0]
  //det(tv[1],v-t[1][0],tab[0][0]+al*tv[0]-t[1][0])=0

  vec3_t u,w;
  vec3Copy(v,u);
  vec3Sub_(tab[1][0],u);
  vec3Copy(tab[0][0],w);
  vec3Sub_(tab[1][0],w);
  vec_t p,q;
  p=det3(tv[1],u,w);
  q=det3(tv[1],u,tv[0]);
  if(q==0.) return false;
  vec_t al=-p/q;
  vec3Copy(tv[0],res[1]);
  vec3Scale_(al,res[1]);
  vec3Add_(tab[0][0],res[1]);
  
  return true;
}

static bool verifstabface(face_t *f,vec3_t st[2])
{
  //printf("verif ");
  //vec3Print(st[0]);
  //vec3Print(st[1]);

  //v=st[0]+t*(st[1]-st[0]);
  //v dot f.p.n + f.p.n[3] == 0
  //st[0]+t*(st[1]-st[0]) dot f.p.n + f.p.n[3] == 0
  //st[0] dot f.p.n +t* (st[1]-st[0]) dot f.p.n + f.p.n[3] == 0
  // t= (-st[0] dot f.p.n - f.p.n[3])/(st[1]-st[0]) dot f.p.n

  vec_t t=-vec3DotProduct(st[0],f->p.n)-f->p.n[3],d;
  vec3_t v;
  vec3Copy(st[1],v);
  vec3Sub_(st[0],v);
  d=vec3DotProduct(v,f->p.n);
  if(d==0.) {
    //printf("KO div 0.\n");
    return false;
  }
  t/=d;
  vec3Scale_(t,v);
  vec3Add_(st[0],v);

  for(unsigned int i=0;i<f->tab.size();i++) {
    plane_t p;
    vec3_t u;
    vec3Copy(f->tab[i].v,u);
    vec3Sub_(f->tab[(i+1)%f->tab.size()].v,u);
    vec3CrossProduct(u,f->p.n,p.n);
    p.n[3]=-vec3DotProduct(p.n,f->tab[i].v);
    p.norm();
    vec_t d=vec3DotProduct(p.n,v)+p.n[3];

    //printf("d=%f\n",d);
    if(d<-EPSILON) {
      //printf("KO\n");
      return false;
    }
  }
  //printf("OK\n");
  return true;
}

static bool verifstab(const vector<face_t*>&f,vec3_t st[2]) 
{
  vec3_t u;
  int d=0;

  vec3Copy(st[1],u);
  vec3Sub_(st[0],u);

  for(unsigned int i=0;i<6;i++)
    if(nanhugeval(st[i/3][i%3]))
      return false;

  for(unsigned int i=0;i<f.size();i++) {
    vec_t c=vec3DotProduct(f[i]->p.n,u);
    if(c>=0.) d=d|1;
    else d=d|2;
    if(d==3) return false;
  }
  for(unsigned int i=0;i<f.size();i++) {
    if(verifstabface(f[i],st)==false) {
      return false;
    }
  }

  return true;
}

// opt:
// garder stab lines 
// lors d'un ajout de face: tester anciens stab (seulement avec new face)
// ajout des nouveaux stab (seulement avec nouvelle face)

// opt?
// virer faces innutiles ?

// opt
// si ancienne stab line n'est plus valable, essayer de remplacer une des lignes par une nouvelle (mieux: par une nouvelle qui a empeche la stab)

static bool stablinestest(const vector<face_t*>&f)
{
  if(f.size()<2) return true;

  unsigned int i,j,k,l;
  unsigned int p,q,r,s;
  //stab pp
  for(i=0;i<f.size();i++)
    for(j=0;j<i;j++)
      for(p=0;p<f[i]->tab.size();p++)
	for(q=0;q<f[j]->tab.size();q++) {
	  vec3_t res[2];
	  vec3Copy(f[i]->tab[p].v,res[0]);
	  vec3Copy(f[j]->tab[q].v,res[1]);
	  if(!vec3EqualEps(res[0],res[1])) 
	    if(verifstab(f,res)) {
#ifdef AFFPVSSTAB
	      printf("pp");
	      vec3Print(res[0]);
	      vec3Print(res[1]);
#endif
	      return true;
	    }
	}
  
  //stab pll
  for(i=0;i<f.size();i++)
    for(j=0;j<f.size();j++)
      for(k=0;k<j;k++) if(i!=j && i!=k)
 	for(p=0;p<f[i]->tab.size();p++)
	  for(q=0;q<f[j]->tab.size();q++) 
	    for(r=0;r<f[k]->tab.size();r++) {
	      vec3_t res[2];
	      vec3_t t[2][2];
	      vec3Copy(f[j]->tab[q].v,t[0][0]);
	      vec3Copy(f[j]->tab[(q+1)%f[j]->tab.size()].v,t[0][1]);
	      vec3Copy(f[k]->tab[r].v,t[1][0]);
	      vec3Copy(f[k]->tab[(r+1)%f[k]->tab.size()].v,t[1][1]);
	      if(pointtwolines(f[i]->tab[p].v,t,res))
		if(verifstab(f,res)) {
#ifdef AFFPVSSTAB
		  printf("pll");
		  vec3Print(res[0]);
		  vec3Print(res[1]);
#endif
		  return true;
		}
	}

  //stab llll
  for(i=0;i<f.size();i++)
    for(j=0;j<i;j++)
      for(k=0;k<j;k++)
	for(l=0;l<k;l++)
	  for(p=0;p<f[i]->tab.size();p++)
	    for(q=0;q<f[j]->tab.size();q++) 
	      for(r=0;r<f[k]->tab.size();r++) 
		for(s=0;s<f[l]->tab.size();s++) {
		  vec3_t res[2][2];
		  vec3_t t[4][2];
		  vec3Copy(f[i]->tab[p].v,t[0][0]);
		  vec3Copy(f[i]->tab[(p+1)%f[i]->tab.size()].v,t[0][1]);
		  vec3Copy(f[j]->tab[q].v,t[1][0]);
		  vec3Copy(f[j]->tab[(q+1)%f[j]->tab.size()].v,t[1][1]);
		  vec3Copy(f[k]->tab[r].v,t[2][0]);
		  vec3Copy(f[k]->tab[(r+1)%f[k]->tab.size()].v,t[2][1]);
		  vec3Copy(f[l]->tab[l].v,t[3][0]);
		  vec3Copy(f[l]->tab[(l+1)%f[l]->tab.size()].v,t[4][1]);
		  if(fourlines(t,res)) {
		    if(verifstab(f,res[0])) {
#ifdef AFFPVSSTAB
		      printf("llll1");
		      vec3Print(res[0][0]);
		      vec3Print(res[0][1]);
#endif
		      return true;
		    }
		    if(verifstab(f,res[1])) {
#ifdef AFFPVSSTAB
		      printf("llll2");
		      vec3Print(res[1][0]);
		      vec3Print(res[1][1]);
#endif
		      return true;
		    }
		  }
		}

  return false;
}

void stabw_t::addface(face_t *fa)
{
  f.push_back(fa);
}

bool stabw_t::vis() const
{
  return stablinestest(f);
}

stabw_t::stabw_t(const stabw_t &o):
  stablines(o.stablines),in(o.in),out(o.out)
{
  f.resize(o.f.size());
  for(unsigned int i=0;i<f.size();i++)
    f[i]=new face_t(*o.f[i]);
}

stabw_t::~stabw_t()
{
  for(unsigned int i=0;i<f.size();i++)
    delete f[i];
}

