#ifndef _rat_hpp_
#define _rat_hpp_

#include <iostream>

/* rationels */
/* OK */

#include "utils.hpp"
#include "integer.hpp"

class rat_t {
public:
  inline rat_t(int__t i):p(i),q(1) {}
  inline rat_t(int i=0):p(i),q(1) {}
  inline rat_t(const rat_t &o):p(o.p),q(o.q){}
  inline ~rat_t(){}
  inline const rat_t &operator =(const rat_t &o) {
    if(this !=&o) {
      p=o.p;
      q=o.q;
    }
    return *this;
  }

  inline const rat_t &operator =(const int o) {
    p=o;
    q=1;
    return *this;
  }

  /***********/

  inline bool operator ==(const rat_t &o) const 
  { return p==o.p && q==o.q; }
  inline bool operator !=(const rat_t &o) const
  { return p!=o.p || q!=o.q; }
  
  inline bool operator <(const rat_t &o) const {rat_t r=*this -o; if(r.p<0) return true; else return false;}
  inline bool operator <=(const rat_t &o) const {rat_t r=*this -o; if(r.p<=0) return true; else return false;}
  inline bool operator >(const rat_t &o) const { return !(*this <= o);}
  inline bool operator >=(const rat_t &o) const { return !(*this < o);}

  inline rat_t operator -() const
  { rat_t r; r.p=-p;r.q=q; return r;}
  
  inline const rat_t &operator +=(const rat_t &o) { 
    int__t d=lcm(q,o.q);
    p=p*d/q+o.p*d/o.q;
    q=d;
    return *this;
  }
  
  inline const rat_t &operator -=(const rat_t &o) {*this +=-o;return *this;}
  inline const rat_t &operator *=(const rat_t &o) {p*=o.p;q*=o.q;simpl(); return *this;}
  inline const rat_t &operator /=(const rat_t &o) {p*=o.q;q*=o.p;simpl(); return *this;}
  
  inline rat_t operator *(const rat_t &o) const
  { rat_t r; r.p=p*o.p; r.q=q*o.q; r.simpl(); return r;}
  inline rat_t operator /(const rat_t &o) const
  { rat_t r; r.p=p*o.q; r.q=q*o.p; r.simpl(); return r;}
  inline rat_t operator +(const rat_t &o) const
  { rat_t r(o); r+=*this; return r;}
  inline rat_t operator -(const rat_t &o) const
  {return (*this)+(-o);}

  friend std::ostream & operator<<(std::ostream &o, const rat_t &z);
  
  friend rat_t abs(const rat_t &o)
  {
    rat_t r(o);
    if(r.p<0) r.p=-r.p;
    return r;
  }

  inline double toDouble() const
  { return p.toDouble()/q.toDouble(); }

#ifdef VECRAT  
  friend rat_t strToVec(char*);
#endif  

  /***********/

protected:
  int__t p,q;
  
  inline void simpl() {
    if(q==0) Error("q=0");
    if(p==0) {q=1;return;}
    int__t d=gcd(p,q);
    if(q<0) d=-d;
    p/=d;
    q/=d;
  }
};

#endif


