#ifndef _TEXT_HPP_
#define _TEXT_HPP_

#include <string.h>
#include <stdlib.h>
#include "vect.hpp"

class text_t {
public:
  text_t(char *n=NULL,vec_t dx_=1,vec_t dy_=1, vec_t sx_=1,vec_t sy_=1):name(n?strdup_(n):n),dx(dx_),dy(dy_),sx(sx_),sy(sy_) {}
  ~text_t() { if(name) free(name);}
  text_t(const text_t &o):name(o.name?strdup_(o.name):NULL),dx(o.dx),dy(o.dy),sx(o.sx),sy(o.sy) {}
  
  const text_t &operator=(const text_t &o){
    if(this!=&o) {
      if(name) free(name);
      if(o.name)
	name=strdup_(o.name);
      else name=NULL;
      dx=o.dx;
      dy=o.dy;
      sx=o.sx;
      sy=o.sy;
    }
    return *this;
  }

  bool operator==(text_t &a)
  {
    if((name && !a.name) || (a.name && !name)) return false;
    if(name && a.name && strcmp(name,a.name)) return false;
    return vecEqual(dx,a.dx) && vecEqual(dy,a.dy) && vecEqual(sx,a.sx) && vecEqual(sy,a.sy);
  }

  bool operator!=(text_t &a) 
  {
    return !(*this==a);
  }

  void print() const {
    if(name) printf("%s %f %f %f %f",name,dx,dy,sx,sy);
    else printf("(NULL)");
  }

  char *name;
  vec_t dx,dy;
  vec_t sx,sy;
};

#endif

