#include "tjunc.hpp"
#include "bsp.hpp"
#include "portal.hpp"
#include <vector>
using namespace std;

static void listvertexface(vector<vertex_t> &v,face_t &f)
{
  for(unsigned int i=0;i<f.tab.size();i++)
    v.push_back(f.tab[i]);
}

// limit=true : seulement les limites
// FIX: trier et enlever doublons
void listvertex_r(vector<vertex_t> &v,bsp_t *b,bool limit)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) { 
      portal_t *p=b->portals[i];
      if(b==p->bsp[0] && (!limit || p->flag & PRT_ZONE))
	for(unsigned int j=0;j<p->listfaces.size();j++) {
	  if(p->listfaces[j]->flags & FACE_DRAW) {
	    face_t *f=p->listfaces[j];
	    listvertexface(v,*f);
	  } //else printf("lala skip %d\n",p->listfaces[j]->flags);
	}
    }
    //for(unsigned int i=0;i<b->portals.size();i++)
    //  if(b->portals[i]->flag & PRT_BLOCK)
    //listvertexface(v,b->portals[i]->face);
  } else {
    listvertex_r(v,b->child[0],limit);
    listvertex_r(v,b->child[1],limit);
  }
}

/*****************/

static int nbrtj;

static void fixTjuncFace(vector<vertex_t> &vv,face_t &f)
{
  for(unsigned int j=0;j<vv.size();j++) {
    vertex_t v=vv[j];
    for(unsigned int i=0;i<f.tab.size();i++) {
      if(v==f.tab[i]) break;
      if(i<f.tab.size()-1 && v==f.tab[i+1]) break;
      if(vertexOnSeg(v,f.tab[i],f.tab[(i+1)%f.tab.size()])) {
	nbrtj++;
	f.insert(i,v);
	break;
      }
    }
  }
}

void fixTjunc_r_(vector<vertex_t> &vv,bsp_t *b)
{
  if(b->leaf) {
    for(unsigned int i=0;i<b->portals.size();i++) {
      portal_t *p=b->portals[i];
      for(unsigned int j=0;j<p->listfaces.size();j++) {
	if(p->listfaces[j]->flags & FACE_DRAW) {
	  fixTjuncFace(vv,*(p->listfaces[j])); 
	}
	//else printf("%d\n",p->listfaces[j]->flags);
      }
    }
    //printf("fix %d\n",vv.size());
  }else {
    vector<vertex_t> v1,v2;
    while(vv.size()){
      vertex_t v=vv[vv.size()-1];
      vv.pop_back();
      int d=b->plane.checkVertex(&v);
      if(d>=0) v1.push_back(v);
      if(d<=0) v2.push_back(v);
    }
    fixTjunc_r_(v1,b->child[0]);
    fixTjunc_r_(v2,b->child[1]);
    }
}

void fixTjunc_r(vector<vertex_t> &vv,bsp_t *b)
{
  nbrtj=0;
  printf("%d vertices\n",vv.size());
  fixTjunc_r_(vv,b);
  printf("%d vertices added\n",nbrtj);
}

/***************/

/*
void fixTjunc(hstr_t *h) // obsolete
{
  vector<vertex_t> vv;
  //nbrtj=0;
  //listhedge.resize(0);
  
  printf("--- FIX T-JUNCTIONS ---\n");
  listvertex_r(vv,h->bsp);
  printf("%d sommets\n",vv.size());
  fixTjunc_r(vv,h->bsp);
  //printf("%d sommets ajoutes pour fixer t-junctions\n",nbrtj);

  // liste hedge
  listhedge_r(h->bsp); 
  //listhedge_leaf(h->ext);
  printf("%d hedge\n",listhedge.size());
  for(unsigned int i=0;i<listhedge.size();i++)
    if(listhedge[i].op<0 || listhedge[i].listcor.size()!=1) {
      printf("%d: op=%d, nbr=%d\n",i,listhedge[i].op,listhedge[i].listcor.size());
      listhedge[i].v1.print();
      listhedge[i].v2.print();
    }

  // correspondance
  // erreur si un vecteur de taille > 1 (dans un premier temps)
}
*/


