#ifndef _vector__hpp_
#define _vector__hpp_

#include <stdlib.h>

#include "utils.hpp"

template <class T> class vector_stat{
public:
  vector_stat():_size(0),_tab(NULL) {}
  vector_stat(unsigned int i):_size(i),_tab((T*)malloc(sizeof(T)*i)) {}
  vector_stat(const vector_stat<T> &o):_size(o._size),_tab((T*)malloc(sizeof(T)*o._size)) {for(unsigned int i=0;i<_size;i++) _tab[i]=o._tab[i]; }
  ~vector_stat() { if(_size) free(_tab); } 

  inline unsigned int size() const {return _size;}
  inline void resize(unsigned int i) {if(i!=_size) {_size=i; _tab=(T*)realloc(_tab,i*sizeof(T));}}
  inline T &operator[](int i) {return _tab[i];}
  inline const T &operator[](int i) const {return _tab[i];}
  vector_stat<T> &operator=(const vector_stat<T> &o) {if(this!=&o) {
    resize(o._size);
    for(unsigned int i=0;i<_size;i++) _tab[i]=o._tab[i];
  } return *this; }
  inline void push_back(const T &o) { resize(_size+1); _tab[_size-1]=o;} 
  
  void exchange(vector_stat<T> &o) {
    unsigned int s=o._size;o._size=_size;_size=s;
    T* t=o._tab;o._tab=_tab;_tab=t;
  }

  unsigned int _size;
  T *_tab;
};

#endif

