#ifndef _vertex_hpp_
#define _vertex_hpp_

#include <vector>
using namespace std;
#include "vect.hpp"
#include "utils.hpp"

class vertex_t {
public:
  vertex_t(vec_t x=0,vec_t y=0,vec_t z=0);
  vertex_t(const vec3_t vv) {vec3Copy(vv,v);}
  vertex_t(const vertex_t &vv) {vec3Copy(vv.v,v);}

  //operator vec3_t() const { return v; }
  
  void print() const;
  bool equal(vertex_t *v) const;
  
  bool operator==(vertex_t &) const;

  void save(ofstream &f) const {for(unsigned int i=0;i<3;i++) saveVec(f,v[i]);}
  void load(ifstream &f) {for(unsigned int i=0;i<3;i++) v[i]=loadVec(f);}

  vec3_t v;
};

class face_t;

class hedge_t : public vertex_t
{
public:
  hedge_t(vec_t x=0,vec_t y=0,vec_t z=0):vertex_t(x,y,z) {}
  hedge_t(const vec3_t vv):vertex_t(vv) {}
  hedge_t(const vertex_t &v):vertex_t(v) {}

  // choix 1
  //hedge_t *op;
  //hedge_t *next;
  //face_t *face;

  // choix 2
  //face_t *op;
  unsigned int op;
  unsigned int indop;
  //face_t *face;
  unsigned int f;
  unsigned int ind;

  // numero au lieu de face_t *?
  // comme bsp, les premiers bits pour la zone, le reste pour les faces
};

//typedef vertex_t hedge_t;

extern bool vertexOnSeg(vertex_t &,vertex_t &,vertex_t &);
extern bool vertexOnLine(vertex_t &,vertex_t &,vertex_t &);

extern void loadVectorVertexAppend(vector<vertex_t> &v,char *f);
extern void saveVectorVertex(vector<vertex_t> &v,char *f);

#endif
