#ifndef _bspfileformat_hpp_
#define _bspfileformat_hpp_

#define VERSIONBSPF 1
#define IDBSPF "SMAP"
#define IDLUMP "SL"
#define IDBSPZONEF "SZON"

struct bspf_head_t {
  int id;
  int version;
  short nbrbitnum; //->char
};

struct bspf_zone_t {
  unsigned int id;
  int version;
  int nbrzones; // -> short
  //bsp des zones
  //char*[]: nom des fichiers pour les zones
  //bb de chaque zone ?
};

enum elumps_t {
  bsp_leaf,
  bsp_int,
  vertex,
  face,
  plane,
  texture,
  //vis,
  //entity,
  end=255
};

struct lump_t {
  unsigned short idlump;
  short ver;
  elumps_t lump;
  int size;
  int nbr;
};

struct bspf_plane_t {
  float n[4];
};

struct bspf_vertex_t {
  float pos[3];
  float norm[3];
  float texpos[2];
  int faceop; //HE
  int indop; // -> char
};

struct bspf_face_t {
  int plane;
  int vertex;
  int nbrvertex;  // -> char ou short
  int texture; // -> short
  int type; // ->char ou short
};


struct bspf_int_t {
  int plane;
  int child[2];
  //BBox ?
  //flag ?
};

#define LEAFBLOCK 1

struct bspf_leaf_t {
  int face;
  int nbrface; // ->short
  //BBox ?
  
  int flag;
};

struct bspf_text_t {
  char name[64];
};

struct bspf_ent_t {
  float pos[3];
  float dir[3];
  char name[64];
};

#endif

