#include "fctbuildin.hpp"
#include "timer.hpp"
#include <stdio.h>
#include <string.h>

static int getint(scr_list_t<scr_val_t> **p)
{
  if(*p) {
    (*p)->info.transtype(TYPEINT);
    int i=(*p)->info.v.i;
    (*p)=(*p)->next;
    return i;
  } 
  else return 0;
}

static char* getstr(scr_list_t<scr_val_t> **p)
{
  if(*p) {
    (*p)->info.transtype(TYPESTRING);
    char *s=(*p)->info.v.s;
    (*p)=(*p)->next;
    return s;
  } 
  else return "";
}

scr_val_t fctprint(scr_list_t<scr_val_t> *a)
{
  while(a) {
    a->info.print();
    a=a->next;
  }
  return scr_val_t(0);
}

scr_val_t fctrand(scr_list_t<scr_val_t> *a)
{
  int i=getint(&a);
  if(i<=0) return scr_val_t(0);
  return scr_val_t(rand()%i);
}

scr_val_t fcttime(scr_list_t<scr_val_t> *a)
{
  return scr_val_t(gametime);
}

scr_val_t fctnewtimer(scr_list_t<scr_val_t> *a)
{
  int time=getint(&a);
  char *s=getstr(&a);
  return scr_val_t(globaltimer.addtimer(time,strdup(s)));
}

fctbuildin_t fctbuildin[]={{fctprint,"print"},{fctrand,"rand"},{fcttime,"time"},{fctnewtimer,"newtimer"}};
int nbrfctbuildin=sizeof(fctbuildin)/sizeof(fctbuildin[0]);

