#include "hashtable.hpp"
#include "log.hpp"

//#include <stdio.h>
//#include <stdlib.h>
#include <string>

static int hashtable_t_hfct(char *name,int nbr)
{
  int h=0,i;

  for(i=0;name[i];i++) h+=name[i];
  
  return h%nbr;
}


hashtable_t::hashtable_t(void (*Hfree)(void *),int Size, int (*Hfct)(char*,int))
  :size(Size)
{
  int i;
  
  hfree=Hfree;
  
  if(Hfct)
    hfct=Hfct;
  else
    hfct=hashtable_t_hfct;
  table=new hashelmt_t*[size];//(hashelmt_t**)malloc(size*sizeof(hashelmt_t*));
  
  for(i=0;i<size;i++)
    table[i]=NULL;
}


hashtable_t::~hashtable_t()
{
  FreeAll();
  free(table);
}

void hashtable_t::FreeAll(void)
{
  int i;
  for(i=0;i<size;i++) {
    hashelmt_t *p=table[i],*t;
    while(p) {
      t=p->next;
      free(p->name);
      //if(hfct) 
      (*hfree)(p->ptr);
      delete p;
      p=t;
    }
    table[i]=NULL;
  }
}


void* hashtable_t::Search(char *name)
{
  int i=(hfct(name,size)%size);
  hashelmt_t *p=table[i];
  
  while(p) {
    if(strcmp(p->name,name)==0)
      return p->ptr;
    p=p->next;
  }
  return NULL;
}


int hashtable_t::Add(char *name,void *ptr)
{
  if(Search(name)) {
    PRINTD("element %s already exist",name);
    return 0;
  }
  
  int i=(hfct(name,size)%size);
  hashelmt_t *p=new hashelmt_t;

  p->name=strdup(name);
  p->ptr=ptr;
  p->next=table[i];
  table[i]=p;

  return 1;
}

void hashtable_t::PrintList(void)
{
  hashelmt_t *p;
  int i;

  for(i=0;i<size;i++) {
    p=table[i];
    while(p) {
      PRINTD("%s",p->name);
      p=p->next;
    }
  }
}

