D			[0-9]
L			[a-zA-Z_]
H			[a-fA-F0-9]
E			[Ee][+-]?{D}+
FS			(f|F|l|L)
IS			(u|U|l|L)*

%{
#include <stdio.h>
#include "function.hpp"
#include "gram.tab.hpp"
#include "string.h"

extern char *bufferfunction;
extern int posbuffct;

void count();
void comment();
void comment2();
//int input();

#define ECHO

#define YY_INPUT(buf,result,max_size) \
{ \
int i;\
for(i=0;i<max_size;){\
if(0==(buf[i]=bufferfunction[posbuffct])) break;\
i++;posbuffct++;}\
if(i==0) result=YY_NULL; else result=i;\
}

/*
0[xX]{H}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;return(CONSTANT); }
0{D}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;return(CONSTANT); }
{D}+{IS}?		{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;yylval.expr->u.d=atoi(return(CONSTANT); }
L?'(\\.|[^\\'])+'	{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONF;return(CONSTANT); }

L?'(\\.|[^\\'])+'	{ count(); return(CONSTANT); }
{D}+{E}{FS}?		{ count(); return(CONSTANT); }

{D}*"."{D}+({E})?{FS}?	{ count(); return(CONSTANT); }
{D}+"."{D}*({E})?{FS}?	{ count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONF;yylval.expr->u.d=atof(yytext);return(CONSTANT); }

{ count(); return(STRING_LITERAL); }

*/

/*    int c = getchar(); 
    result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); */


%}

%%
"/*"			{ comment(); }
"//"                    { comment2(); }

"auto"			{ count(); return(AUTO); }
"break"			{ count(); return(BREAK); }
"case"			{ count(); return(CASE); }
"char"			{ count(); return(CHAR); }
"const"			{ count(); return(CONST); }
"continue"		{ count(); return(CONTINUE); }
"default"		{ count(); return(DEFAULT); }
"do"			{ count(); return(DO); }
"double"		{ count(); return(DOUBLE); }
"else"			{ count(); return(ELSE); }
"enum"			{ count(); return(ENUM); }
"extern"		{ count(); return(EXTERN); }
"float"			{ count(); return(FLOAT); }
"for"			{ count(); return(FOR); }
"goto"			{ count(); return(GOTO); }
"if"			{ count(); return(IF); }
"ife"                   { count(); return(IFE); }
"int"			{ count(); return(INT); }
"bool"			{ count(); return(BOOL); }
"string"		{ count(); return(STRING); }
"long"			{ count(); return(LONG); }
"register"		{ count(); return(REGISTER); }
"return"		{ count(); return(RETURN); }
"short"			{ count(); return(SHORT); }
"signed"		{ count(); return(SIGNED); }
"sizeof"		{ count(); return(SIZEOF); }
"static"		{ count(); return(STATIC); }
"struct"		{ count(); return(STRUCT); }
"switch"		{ count(); return(SWITCH); }
"typedef"		{ count(); return(TYPEDEF); }
"union"			{ count(); return(UNION); }
"unsigned"		{ count(); return(UNSIGNED); }
"void"			{ count(); return(VOID); }
"volatile"		{ count(); return(VOLATILE); }
"while"			{ count(); return(WHILE); }
"global"                { count(); return(GLOBAL); }
"true"		        { count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;yylval.expr->u.i=1;return(CONSTANT); }
"false"		        { count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;yylval.expr->u.i=0;return(CONSTANT); }
"endl"			{count(); yylval.expr=new scr_expr_t;yylval.expr->op=OPCONS;yylval.expr->u.s=strdup("\n");return(CONSTANT);}


{L}({L}|{D})*		{ count(); yylval.name=strdup(yytext); return(IDENTIFIER);/*return(check_type());*/ }

{D}+		        { count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONI;yylval.expr->u.i=atoi(yytext);return(CONSTANT); }
{D}+"."{D}*	        { count(); yylval.expr=new scr_expr_t; yylval.expr->op=OPCONF;yylval.expr->u.d=atof(yytext);return(CONSTANT); }


L?\"(\\.|[^\\"])*\"	{ count(); yylval.expr=new scr_expr_t;yylval.expr->op=OPCONS;yylval.expr->u.s=strdup(yytext+1);int i=0;while(yylval.expr->u.s[i])i++;yylval.expr->u.s[i-1]=0;return(CONSTANT);
}

"..."			{ count(); return(ELLIPSIS); }
">>="			{ count(); return(RIGHT_ASSIGN); }
"<<="			{ count(); return(LEFT_ASSIGN); }
"+="			{ count(); return(ADD_ASSIGN); }
"-="			{ count(); return(SUB_ASSIGN); }
"*="			{ count(); return(MUL_ASSIGN); }
"/="			{ count(); return(DIV_ASSIGN); }
"%="			{ count(); return(MOD_ASSIGN); }
"&="			{ count(); return(AND_ASSIGN); }
"^="			{ count(); return(XOR_ASSIGN); }
"|="			{ count(); return(OR_ASSIGN); }
">>"			{ count(); return(RIGHT_OP); }
"<<"			{ count(); return(LEFT_OP); }
"++"			{ count(); return(INC_OP); }
"--"			{ count(); return(DEC_OP); }
"->"			{ count(); return(PTR_OP); }
"&&"			{ count(); return(AND_OP); }
"||"			{ count(); return(OR_OP); }
"<="			{ count(); return(LE_OP); }
">="			{ count(); return(GE_OP); }
"=="			{ count(); return(EQ_OP); }
"!="			{ count(); return(NE_OP); }
";"			{ count(); return(';'); }
("{"|"<%")		{ count(); return('{'); }
("}"|"%>")		{ count(); return('}'); }
","			{ count(); return(','); }
":"			{ count(); return(':'); }
"="			{ count(); return('='); }
"("			{ count(); return('('); }
")"			{ count(); return(')'); }
("["|"<:")		{ count(); return('['); }
("]"|":>")		{ count(); return(']'); }
"."			{ count(); return('.'); }
"&"			{ count(); return('&'); }
"!"			{ count(); return('!'); }
"~"			{ count(); return('~'); }
"-"			{ count(); return('-'); }
"+"			{ count(); return('+'); }
"*"			{ count(); return('*'); }
"/"			{ count(); return('/'); }
"%"			{ count(); return('%'); }
"<"			{ count(); return('<'); }
">"			{ count(); return('>'); }
"^"			{ count(); return('^'); }
"|"			{ count(); return('|'); }
"?"			{ count(); return('?'); }

[ \t\v\n\f]		{ count(); }
.			{ /* ignore bad characters */ }

%%


int yywrap()
{
	return(1);
}


void comment()
{
	char c, c1;

loop:
	while ((c = yyinput()) != '*' && c != 0)
		putchar(c);

	if ((c1 = yyinput()) != '/' && c != 0)
	{
		unput(c1);
		goto loop;
	}

	if (c != 0)
		putchar(c1);
}

void comment2()
{
	char c, c1;

/*loop:*/
	while ((c = yyinput()) != '\n' && c != 0)
		putchar(c);

/*	if ((c1 = yyinput()) != '/' && c != 0)
	{
		unput(c1);
		goto loop;
	}*/

	if (c != 0)
		putchar(c1);
}


int column = 0;

void count()
{
	int i;

	for (i = 0; yytext[i] != '\0'; i++)
		if (yytext[i] == '\n')
			column = 0;
		else if (yytext[i] == '\t')
			column += 8 - (column % 8);
		else
			column++;

	ECHO;
}


int check_type()
{
/*
* pseudo code --- this is what it should check
*
*	if (yytext == type_name)
*		return(TYPE_NAME);
*
*	return(IDENTIFIER);
*/

/*
*	it actually will only return IDENTIFIER
*/

	return(IDENTIFIER);
}
