#ifndef _pvar_hpp_
#define _pvar_hpp_

#include "hashtable.hpp"

enum pvar_type_t {tnone, tchar, tint, tfloat, tdouble, tstring};

#define PVAR_RO 1
#define PVAR_PROG 256

typedef struct {
  pvar_type_t type;
  //int size;
  void *ptr;
  int flags;
} pvar_elm_t;

class pvar_t {
public:
  pvar_t(int Size=71);
  ~pvar_t();
  
  void Add(char *name, pvar_type_t type, int flags, void *ptr=0);
  
  void Set(char *name, char *value);
  void Seti(char *name,int);
  void Setf(char *name,double);
  
  int Search(char* name);

  pvar_type_t GetType(char *name);

  char* Get(char *name);
  int Geti(char *name);
  double Getf(char *name);
  //delete
  //list

  void PrintList(void);

protected:
  static void hfree(void *);
  
  hashtable_t ht;
};

#endif
