#include "scr_var.hpp"
#include "log.hpp"
//#include <stdio.h>
#include "function.hpp"

// lire: cherche dans l'ordre local,global,program
scr_val_t scr_getvar(pvar_t *lv,char *name)
{
  pvar_t *vars;
  scr_val_t r;
  r.type=NOTYPE;
  r.name=NULL;

  if(lv->Search(name))
    vars=lv;
  else if(globalvars.Search(name))
    vars=&globalvars;
  else if(programvars.Search(name))
    vars=&programvars;
  else return r;
  
  switch(vars->GetType(name)){
  case tint:
  case tchar:
    r.type=TYPEINT;
    r.v.i=vars->Geti(name);
    break;
  case tdouble:
  case tfloat:
    r.type=TYPEDOUBLE;
    r.v.d=vars->Getf(name);
    break;
  case tstring:
    r.type=TYPESTRING;
    r.v.s=vars->Get(name);
    break;
  default:
    break;
  }
  return r;
}

void scr_setvar(pvar_t *lv,char *name,scr_val_t v)
{
  pvar_t *vars;

  if(lv->Search(name))
    vars=lv;
  else if(globalvars.Search(name))
    vars=&globalvars;
  else if(programvars.Search(name))
    vars=&programvars;
  else return; //hum
  
  switch(v.type) {
  case TYPEINT:
    vars->Seti(name,v.v.i);
    break;
  case TYPEDOUBLE:
    vars->Setf(name,v.v.d);
    break;
  case TYPESTRING:
    vars->Set(name,v.v.s);
    break;
  }
  
 /*...*/
}

void scr_registervar(pvar_t *lv,char *name,int t)
{
  /* tester si elle n'existe pas deja*/
  if(lv->Search(name)) {
    PRINTD("registervar: local var %s already exist",name);
    return;
  }
  
  if(t & TYPEGLOBAL)
    if(globalvars.Search(name)) {
      PRINTD("registervr: global var %s already exist",name);
      return;
    }

  pvar_t *vars;

  //printf("reg %s type %d\n",name,t);
  
  if(t & TYPEGLOBAL)
    vars=&globalvars;
  else
    vars=lv;

  t=t&255;
  
  switch(t) {
  case TYPEDOUBLE:
    vars->Add(name,tdouble,0);
    break;
  case TYPEINT:
    vars->Add(name,tint,0);
    break;
  case TYPESTRING:
    vars->Add(name,tstring,0);
    break;
  }
}

//void scr_destroylocalvars()
//{
  // hum
  // localvars.destroy();
//}
